/* DeepinBlurEffect.c generated by valac 0.43.91, the Vala compiler
 * generated from DeepinBlurEffect.vala, do not modify */

/**/
/*  Copyright (C) 2015 Deepin Technology Co., Ltd.*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <clutter/clutter.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <cogl/cogl.h>

#define GALA_TYPE_DEEPIN_BLUR_EFFECT (gala_deepin_blur_effect_get_type ())
#define GALA_DEEPIN_BLUR_EFFECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_DEEPIN_BLUR_EFFECT, GalaDeepinBlurEffect))
#define GALA_DEEPIN_BLUR_EFFECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_DEEPIN_BLUR_EFFECT, GalaDeepinBlurEffectClass))
#define GALA_IS_DEEPIN_BLUR_EFFECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_DEEPIN_BLUR_EFFECT))
#define GALA_IS_DEEPIN_BLUR_EFFECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_DEEPIN_BLUR_EFFECT))
#define GALA_DEEPIN_BLUR_EFFECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_DEEPIN_BLUR_EFFECT, GalaDeepinBlurEffectClass))

typedef struct _GalaDeepinBlurEffect GalaDeepinBlurEffect;
typedef struct _GalaDeepinBlurEffectClass GalaDeepinBlurEffectClass;
typedef struct _GalaDeepinBlurEffectPrivate GalaDeepinBlurEffectPrivate;
enum  {
	GALA_DEEPIN_BLUR_EFFECT_0_PROPERTY,
	GALA_DEEPIN_BLUR_EFFECT_HORIZONTAL_PROPERTY,
	GALA_DEEPIN_BLUR_EFFECT_WIDTH_PROPERTY,
	GALA_DEEPIN_BLUR_EFFECT_HEIGHT_PROPERTY,
	GALA_DEEPIN_BLUR_EFFECT_RADIUS_PROPERTY,
	GALA_DEEPIN_BLUR_EFFECT_BLOOM_PROPERTY,
	GALA_DEEPIN_BLUR_EFFECT_NUM_PROPERTIES
};
static GParamSpec* gala_deepin_blur_effect_properties[GALA_DEEPIN_BLUR_EFFECT_NUM_PROPERTIES];
#define _cogl_program_unref0(var) ((var == NULL) ? NULL : (var = (cogl_program_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cogl_material_unref0(var) ((var == NULL) ? NULL : (var = (cogl_material_unref (var), NULL)))
#define _cogl_shader_unref0(var) ((var == NULL) ? NULL : (var = (cogl_shader_unref (var), NULL)))

struct _GalaDeepinBlurEffect {
	ClutterOffscreenEffect parent_instance;
	GalaDeepinBlurEffectPrivate * priv;
};

struct _GalaDeepinBlurEffectClass {
	ClutterOffscreenEffectClass parent_class;
};

struct _GalaDeepinBlurEffectPrivate {
	gboolean _horizontal;
	gint _width;
	gint _height;
	gfloat _radius;
	gfloat _bloom;
	CoglHandle* program;
};

static gint GalaDeepinBlurEffect_private_offset;
static gpointer gala_deepin_blur_effect_parent_class = NULL;

#define GALA_BLUR_SHADER_FRAG_H_CODE "\n" \
"// Fragment Shader horizontal\n" \
"uniform sampler2D texture;\n" \
"uniform int width;\n" \
"uniform float radius;\n" \
"uniform float bloom;\n" \
"\n" \
"void main()\n" \
"{\n" \
"\tfloat v;\n" \
"\tfloat pi = 3.141592653589793;\n" \
"\tfloat e_step = 1.0 / width;\n" \
"\tfloat rel_radius = radius;\n" \
"\tif (rel_radius < 0) rel_radius = 0;\n" \
"\tint steps = int(min(rel_radius * 0.7, sqrt(rel_radius) * pi));\n" \
"\tfloat r = rel_radius / steps;\n" \
"\tfloat t = bloom / (steps * 2 + 1);\n" \
"\tfloat x = cogl_tex_coord_in[0].x;\n" \
"\tfloat y = cogl_tex_coord_in[0].y;\n" \
"\tvec4 sum = texture2D(texture, vec2(x, y)) * t;\n" \
"\tint i;\n" \
"\tfor(i = 1; i <= steps; i++){\n" \
"\t\tv = (cos(i / (steps + 1) / pi) + 1) * 0.5;\n" \
"\t\tsum += texture2D(texture, vec2(x + i * e_step * r, y)) * v * t;\n" \
"\t\tsum += texture2D(texture, vec2(x - i * e_step * r, y)) * v * t;\n" \
"\t}\n" \
"\n" \
"    cogl_color_out = sum;\n" \
"}\n"
#define GALA_BLUR_SHADER_FRAG_V_CODE "\n" \
"// Fragment Shader vertical\n" \
"uniform sampler2D texture;\n" \
"uniform int height;\n" \
"uniform float radius;\n" \
"uniform float bloom;\n" \
"\n" \
"void main()\n" \
"{\n" \
"\tfloat v;\n" \
"\tfloat pi = 3.141592653589793;\n" \
"\tfloat e_step = 1.0 / height;\n" \
"\tfloat rel_radius = radius;\n" \
"\tif (rel_radius < 0) rel_radius = 0;\n" \
"\tint steps = int(min(rel_radius * 0.7, sqrt(rel_radius) * pi));\n" \
"\tfloat r = rel_radius / steps;\n" \
"\tfloat t = bloom / (steps * 2 + 1);\n" \
"\tfloat x = cogl_tex_coord_in[0].x;\n" \
"\tfloat y = cogl_tex_coord_in[0].y;\n" \
"\tvec4 sum = texture2D(texture, vec2(x, y)) * t;\n" \
"\tint i;\n" \
"\tfor(i = 1; i <= steps; i++){\n" \
"\t\tv = (cos(i / (steps + 1) / pi) + 1) * 0.5;\n" \
"\t\tsum += texture2D(texture, vec2(x, y + i * e_step * r)) * v * t;\n" \
"\t\tsum += texture2D(texture, vec2(x, y - i * e_step * r)) * v * t;\n" \
"\t}\n" \
"\n" \
"    cogl_color_out = sum;\n" \
"}\n"
GType gala_deepin_blur_effect_get_type (void) G_GNUC_CONST;
GalaDeepinBlurEffect* gala_deepin_blur_effect_new (gboolean horizontal,
                                                   gint width,
                                                   gint height,
                                                   gfloat radius,
                                                   gfloat bloom);
GalaDeepinBlurEffect* gala_deepin_blur_effect_construct (GType object_type,
                                                         gboolean horizontal,
                                                         gint width,
                                                         gint height,
                                                         gfloat radius,
                                                         gfloat bloom);
void gala_deepin_blur_effect_setup (ClutterActor* actor,
                                    gfloat radius,
                                    gint repeat);
void gala_deepin_blur_effect_update_size (GalaDeepinBlurEffect* self,
                                          gint new_width,
                                          gint new_height);
static void gala_deepin_blur_effect_real_paint_target (ClutterOffscreenEffect* base);
gboolean gala_deepin_blur_effect_get_horizontal (GalaDeepinBlurEffect* self);
static void gala_deepin_blur_effect_set_horizontal (GalaDeepinBlurEffect* self,
                                             gboolean value);
gint gala_deepin_blur_effect_get_width (GalaDeepinBlurEffect* self);
static void gala_deepin_blur_effect_set_width (GalaDeepinBlurEffect* self,
                                        gint value);
gint gala_deepin_blur_effect_get_height (GalaDeepinBlurEffect* self);
static void gala_deepin_blur_effect_set_height (GalaDeepinBlurEffect* self,
                                         gint value);
gfloat gala_deepin_blur_effect_get_radius (GalaDeepinBlurEffect* self);
static void gala_deepin_blur_effect_set_radius (GalaDeepinBlurEffect* self,
                                         gfloat value);
gfloat gala_deepin_blur_effect_get_bloom (GalaDeepinBlurEffect* self);
static void gala_deepin_blur_effect_set_bloom (GalaDeepinBlurEffect* self,
                                        gfloat value);
static GObject * gala_deepin_blur_effect_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void gala_deepin_blur_effect_finalize (GObject * obj);
static void _vala_gala_deepin_blur_effect_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_gala_deepin_blur_effect_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

static inline gpointer
gala_deepin_blur_effect_get_instance_private (GalaDeepinBlurEffect* self)
{
	return G_STRUCT_MEMBER_P (self, GalaDeepinBlurEffect_private_offset);
}

GalaDeepinBlurEffect*
gala_deepin_blur_effect_construct (GType object_type,
                                   gboolean horizontal,
                                   gint width,
                                   gint height,
                                   gfloat radius,
                                   gfloat bloom)
{
	GalaDeepinBlurEffect * self = NULL;
#line 95 "Deepin/DeepinBlurEffect.vala"
	self = (GalaDeepinBlurEffect*) g_object_new (object_type, "horizontal", horizontal, "width", width, "height", height, "radius", radius, "bloom", bloom, NULL);
#line 93 "Deepin/DeepinBlurEffect.vala"
	return self;
#line 145 "DeepinBlurEffect.c"
}

GalaDeepinBlurEffect*
gala_deepin_blur_effect_new (gboolean horizontal,
                             gint width,
                             gint height,
                             gfloat radius,
                             gfloat bloom)
{
#line 93 "Deepin/DeepinBlurEffect.vala"
	return gala_deepin_blur_effect_construct (GALA_TYPE_DEEPIN_BLUR_EFFECT, horizontal, width, height, radius, bloom);
#line 157 "DeepinBlurEffect.c"
}

void
gala_deepin_blur_effect_setup (ClutterActor* actor,
                               gfloat radius,
                               gint repeat)
{
#line 126 "Deepin/DeepinBlurEffect.vala"
	g_return_if_fail (actor != NULL);
#line 167 "DeepinBlurEffect.c"
	{
		gint i = 0;
#line 128 "Deepin/DeepinBlurEffect.vala"
		i = 0;
#line 172 "DeepinBlurEffect.c"
		{
			gboolean _tmp0_ = FALSE;
#line 128 "Deepin/DeepinBlurEffect.vala"
			_tmp0_ = TRUE;
#line 128 "Deepin/DeepinBlurEffect.vala"
			while (TRUE) {
#line 179 "DeepinBlurEffect.c"
				gfloat _tmp2_;
				gfloat _tmp3_;
				gfloat _tmp4_;
				gfloat _tmp5_;
				GalaDeepinBlurEffect* _tmp6_;
				GalaDeepinBlurEffect* _tmp7_;
				gfloat _tmp8_;
				gfloat _tmp9_;
				gfloat _tmp10_;
				gfloat _tmp11_;
				GalaDeepinBlurEffect* _tmp12_;
				GalaDeepinBlurEffect* _tmp13_;
#line 128 "Deepin/DeepinBlurEffect.vala"
				if (!_tmp0_) {
#line 194 "DeepinBlurEffect.c"
					gint _tmp1_;
#line 128 "Deepin/DeepinBlurEffect.vala"
					_tmp1_ = i;
#line 128 "Deepin/DeepinBlurEffect.vala"
					i = _tmp1_ + 1;
#line 200 "DeepinBlurEffect.c"
				}
#line 128 "Deepin/DeepinBlurEffect.vala"
				_tmp0_ = FALSE;
#line 128 "Deepin/DeepinBlurEffect.vala"
				if (!(i < repeat)) {
#line 128 "Deepin/DeepinBlurEffect.vala"
					break;
#line 208 "DeepinBlurEffect.c"
				}
#line 129 "Deepin/DeepinBlurEffect.vala"
				_tmp2_ = clutter_actor_get_width (actor);
#line 129 "Deepin/DeepinBlurEffect.vala"
				_tmp3_ = _tmp2_;
#line 129 "Deepin/DeepinBlurEffect.vala"
				_tmp4_ = clutter_actor_get_height (actor);
#line 129 "Deepin/DeepinBlurEffect.vala"
				_tmp5_ = _tmp4_;
#line 129 "Deepin/DeepinBlurEffect.vala"
				_tmp6_ = gala_deepin_blur_effect_new (TRUE, (gint) _tmp3_, (gint) _tmp5_, radius, 1.0f);
#line 129 "Deepin/DeepinBlurEffect.vala"
				g_object_ref_sink (_tmp6_);
#line 129 "Deepin/DeepinBlurEffect.vala"
				_tmp7_ = _tmp6_;
#line 129 "Deepin/DeepinBlurEffect.vala"
				clutter_actor_add_effect (actor, (ClutterEffect*) _tmp7_);
#line 129 "Deepin/DeepinBlurEffect.vala"
				_g_object_unref0 (_tmp7_);
#line 130 "Deepin/DeepinBlurEffect.vala"
				_tmp8_ = clutter_actor_get_width (actor);
#line 130 "Deepin/DeepinBlurEffect.vala"
				_tmp9_ = _tmp8_;
#line 130 "Deepin/DeepinBlurEffect.vala"
				_tmp10_ = clutter_actor_get_height (actor);
#line 130 "Deepin/DeepinBlurEffect.vala"
				_tmp11_ = _tmp10_;
#line 130 "Deepin/DeepinBlurEffect.vala"
				_tmp12_ = gala_deepin_blur_effect_new (FALSE, (gint) _tmp9_, (gint) _tmp11_, radius, 1.0f);
#line 130 "Deepin/DeepinBlurEffect.vala"
				g_object_ref_sink (_tmp12_);
#line 130 "Deepin/DeepinBlurEffect.vala"
				_tmp13_ = _tmp12_;
#line 130 "Deepin/DeepinBlurEffect.vala"
				clutter_actor_add_effect (actor, (ClutterEffect*) _tmp13_);
#line 130 "Deepin/DeepinBlurEffect.vala"
				_g_object_unref0 (_tmp13_);
#line 246 "DeepinBlurEffect.c"
			}
		}
	}
}

void
gala_deepin_blur_effect_update_size (GalaDeepinBlurEffect* self,
                                     gint new_width,
                                     gint new_height)
{
	gint uniform_no = 0;
	CoglHandle* _tmp0_;
	CoglHandle* _tmp1_;
	CoglHandle* _tmp2_;
	CoglHandle* _tmp3_;
#line 134 "Deepin/DeepinBlurEffect.vala"
	g_return_if_fail (self != NULL);
#line 137 "Deepin/DeepinBlurEffect.vala"
	_tmp0_ = self->priv->program;
#line 137 "Deepin/DeepinBlurEffect.vala"
	uniform_no = cogl_program_get_uniform_location (_tmp0_, "width");
#line 138 "Deepin/DeepinBlurEffect.vala"
	_tmp1_ = self->priv->program;
#line 138 "Deepin/DeepinBlurEffect.vala"
	cogl_program_set_uniform_1i (_tmp1_, uniform_no, new_width);
#line 139 "Deepin/DeepinBlurEffect.vala"
	_tmp2_ = self->priv->program;
#line 139 "Deepin/DeepinBlurEffect.vala"
	uniform_no = cogl_program_get_uniform_location (_tmp2_, "height");
#line 140 "Deepin/DeepinBlurEffect.vala"
	_tmp3_ = self->priv->program;
#line 140 "Deepin/DeepinBlurEffect.vala"
	cogl_program_set_uniform_1i (_tmp3_, uniform_no, new_height);
#line 280 "DeepinBlurEffect.c"
}

static gpointer
_cogl_material_ref0 (gpointer self)
{
#line 145 "Deepin/DeepinBlurEffect.vala"
	return self ? cogl_material_ref (self) : NULL;
#line 288 "DeepinBlurEffect.c"
}

static void
gala_deepin_blur_effect_real_paint_target (ClutterOffscreenEffect* base)
{
	GalaDeepinBlurEffect * self;
	CoglHandle* material = NULL;
	CoglHandle* _tmp0_;
	CoglHandle* _tmp1_;
	CoglHandle* _tmp2_;
#line 143 "Deepin/DeepinBlurEffect.vala"
	self = (GalaDeepinBlurEffect*) base;
#line 145 "Deepin/DeepinBlurEffect.vala"
	_tmp0_ = clutter_offscreen_effect_get_target ((ClutterOffscreenEffect*) self);
#line 145 "Deepin/DeepinBlurEffect.vala"
	_tmp1_ = _cogl_material_ref0 (_tmp0_);
#line 145 "Deepin/DeepinBlurEffect.vala"
	material = _tmp1_;
#line 146 "Deepin/DeepinBlurEffect.vala"
	_tmp2_ = self->priv->program;
#line 146 "Deepin/DeepinBlurEffect.vala"
	cogl_material_set_user_program (material, _tmp2_);
#line 147 "Deepin/DeepinBlurEffect.vala"
	CLUTTER_OFFSCREEN_EFFECT_CLASS (gala_deepin_blur_effect_parent_class)->paint_target (G_TYPE_CHECK_INSTANCE_CAST (self, clutter_offscreen_effect_get_type (), ClutterOffscreenEffect));
#line 143 "Deepin/DeepinBlurEffect.vala"
	_cogl_material_unref0 (material);
#line 315 "DeepinBlurEffect.c"
}

gboolean
gala_deepin_blur_effect_get_horizontal (GalaDeepinBlurEffect* self)
{
	gboolean result;
#line 85 "Deepin/DeepinBlurEffect.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 85 "Deepin/DeepinBlurEffect.vala"
	result = self->priv->_horizontal;
#line 85 "Deepin/DeepinBlurEffect.vala"
	return result;
#line 328 "DeepinBlurEffect.c"
}

static void
gala_deepin_blur_effect_set_horizontal (GalaDeepinBlurEffect* self,
                                        gboolean value)
{
#line 85 "Deepin/DeepinBlurEffect.vala"
	g_return_if_fail (self != NULL);
#line 85 "Deepin/DeepinBlurEffect.vala"
	if (gala_deepin_blur_effect_get_horizontal (self) != value) {
#line 85 "Deepin/DeepinBlurEffect.vala"
		self->priv->_horizontal = value;
#line 85 "Deepin/DeepinBlurEffect.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_deepin_blur_effect_properties[GALA_DEEPIN_BLUR_EFFECT_HORIZONTAL_PROPERTY]);
#line 343 "DeepinBlurEffect.c"
	}
}

gint
gala_deepin_blur_effect_get_width (GalaDeepinBlurEffect* self)
{
	gint result;
#line 86 "Deepin/DeepinBlurEffect.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 86 "Deepin/DeepinBlurEffect.vala"
	result = self->priv->_width;
#line 86 "Deepin/DeepinBlurEffect.vala"
	return result;
#line 357 "DeepinBlurEffect.c"
}

static void
gala_deepin_blur_effect_set_width (GalaDeepinBlurEffect* self,
                                   gint value)
{
#line 86 "Deepin/DeepinBlurEffect.vala"
	g_return_if_fail (self != NULL);
#line 86 "Deepin/DeepinBlurEffect.vala"
	if (gala_deepin_blur_effect_get_width (self) != value) {
#line 86 "Deepin/DeepinBlurEffect.vala"
		self->priv->_width = value;
#line 86 "Deepin/DeepinBlurEffect.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_deepin_blur_effect_properties[GALA_DEEPIN_BLUR_EFFECT_WIDTH_PROPERTY]);
#line 372 "DeepinBlurEffect.c"
	}
}

gint
gala_deepin_blur_effect_get_height (GalaDeepinBlurEffect* self)
{
	gint result;
#line 87 "Deepin/DeepinBlurEffect.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 87 "Deepin/DeepinBlurEffect.vala"
	result = self->priv->_height;
#line 87 "Deepin/DeepinBlurEffect.vala"
	return result;
#line 386 "DeepinBlurEffect.c"
}

static void
gala_deepin_blur_effect_set_height (GalaDeepinBlurEffect* self,
                                    gint value)
{
#line 87 "Deepin/DeepinBlurEffect.vala"
	g_return_if_fail (self != NULL);
#line 87 "Deepin/DeepinBlurEffect.vala"
	if (gala_deepin_blur_effect_get_height (self) != value) {
#line 87 "Deepin/DeepinBlurEffect.vala"
		self->priv->_height = value;
#line 87 "Deepin/DeepinBlurEffect.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_deepin_blur_effect_properties[GALA_DEEPIN_BLUR_EFFECT_HEIGHT_PROPERTY]);
#line 401 "DeepinBlurEffect.c"
	}
}

gfloat
gala_deepin_blur_effect_get_radius (GalaDeepinBlurEffect* self)
{
	gfloat result;
#line 88 "Deepin/DeepinBlurEffect.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 88 "Deepin/DeepinBlurEffect.vala"
	result = self->priv->_radius;
#line 88 "Deepin/DeepinBlurEffect.vala"
	return result;
#line 415 "DeepinBlurEffect.c"
}

static void
gala_deepin_blur_effect_set_radius (GalaDeepinBlurEffect* self,
                                    gfloat value)
{
#line 88 "Deepin/DeepinBlurEffect.vala"
	g_return_if_fail (self != NULL);
#line 88 "Deepin/DeepinBlurEffect.vala"
	if (gala_deepin_blur_effect_get_radius (self) != value) {
#line 88 "Deepin/DeepinBlurEffect.vala"
		self->priv->_radius = value;
#line 88 "Deepin/DeepinBlurEffect.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_deepin_blur_effect_properties[GALA_DEEPIN_BLUR_EFFECT_RADIUS_PROPERTY]);
#line 430 "DeepinBlurEffect.c"
	}
}

gfloat
gala_deepin_blur_effect_get_bloom (GalaDeepinBlurEffect* self)
{
	gfloat result;
#line 89 "Deepin/DeepinBlurEffect.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 89 "Deepin/DeepinBlurEffect.vala"
	result = self->priv->_bloom;
#line 89 "Deepin/DeepinBlurEffect.vala"
	return result;
#line 444 "DeepinBlurEffect.c"
}

static void
gala_deepin_blur_effect_set_bloom (GalaDeepinBlurEffect* self,
                                   gfloat value)
{
#line 89 "Deepin/DeepinBlurEffect.vala"
	g_return_if_fail (self != NULL);
#line 89 "Deepin/DeepinBlurEffect.vala"
	if (gala_deepin_blur_effect_get_bloom (self) != value) {
#line 89 "Deepin/DeepinBlurEffect.vala"
		self->priv->_bloom = value;
#line 89 "Deepin/DeepinBlurEffect.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_deepin_blur_effect_properties[GALA_DEEPIN_BLUR_EFFECT_BLOOM_PROPERTY]);
#line 459 "DeepinBlurEffect.c"
	}
}

static GObject *
gala_deepin_blur_effect_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaDeepinBlurEffect * self;
	CoglHandle* _tmp0_;
	CoglHandle* shader = NULL;
	CoglHandle* _tmp1_;
	gboolean _tmp2_;
	CoglHandle* _tmp5_;
	CoglHandle* _tmp6_;
	CoglHandle* _tmp7_;
	CoglHandle* _tmp8_;
	gint uniform_no = 0;
	CoglHandle* _tmp9_;
	CoglHandle* _tmp10_;
	CoglHandle* _tmp11_;
	CoglHandle* _tmp12_;
	gint _tmp13_;
	CoglHandle* _tmp14_;
	CoglHandle* _tmp15_;
	gint _tmp16_;
	CoglHandle* _tmp17_;
	CoglHandle* _tmp18_;
	gfloat _tmp19_;
	CoglHandle* _tmp20_;
	CoglHandle* _tmp21_;
	gfloat _tmp22_;
#line 98 "Deepin/DeepinBlurEffect.vala"
	parent_class = G_OBJECT_CLASS (gala_deepin_blur_effect_parent_class);
#line 98 "Deepin/DeepinBlurEffect.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 98 "Deepin/DeepinBlurEffect.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_DEEPIN_BLUR_EFFECT, GalaDeepinBlurEffect);
#line 100 "Deepin/DeepinBlurEffect.vala"
	_tmp0_ = (CoglHandle*) cogl_create_program ();
#line 100 "Deepin/DeepinBlurEffect.vala"
	_cogl_program_unref0 (self->priv->program);
#line 100 "Deepin/DeepinBlurEffect.vala"
	self->priv->program = _tmp0_;
#line 102 "Deepin/DeepinBlurEffect.vala"
	_tmp1_ = (CoglHandle*) cogl_create_shader (COGL_SHADER_TYPE_FRAGMENT);
#line 102 "Deepin/DeepinBlurEffect.vala"
	shader = _tmp1_;
#line 103 "Deepin/DeepinBlurEffect.vala"
	_tmp2_ = self->priv->_horizontal;
#line 103 "Deepin/DeepinBlurEffect.vala"
	if (_tmp2_) {
#line 514 "DeepinBlurEffect.c"
		CoglHandle* _tmp3_;
#line 104 "Deepin/DeepinBlurEffect.vala"
		_tmp3_ = shader;
#line 104 "Deepin/DeepinBlurEffect.vala"
		cogl_shader_source (_tmp3_, GALA_BLUR_SHADER_FRAG_H_CODE);
#line 520 "DeepinBlurEffect.c"
	} else {
		CoglHandle* _tmp4_;
#line 106 "Deepin/DeepinBlurEffect.vala"
		_tmp4_ = shader;
#line 106 "Deepin/DeepinBlurEffect.vala"
		cogl_shader_source (_tmp4_, GALA_BLUR_SHADER_FRAG_V_CODE);
#line 527 "DeepinBlurEffect.c"
	}
#line 108 "Deepin/DeepinBlurEffect.vala"
	_tmp5_ = shader;
#line 108 "Deepin/DeepinBlurEffect.vala"
	cogl_shader_compile (_tmp5_);
#line 109 "Deepin/DeepinBlurEffect.vala"
	_tmp6_ = self->priv->program;
#line 109 "Deepin/DeepinBlurEffect.vala"
	_tmp7_ = shader;
#line 109 "Deepin/DeepinBlurEffect.vala"
	cogl_program_attach_shader (_tmp6_, _tmp7_);
#line 111 "Deepin/DeepinBlurEffect.vala"
	_tmp8_ = self->priv->program;
#line 111 "Deepin/DeepinBlurEffect.vala"
	cogl_program_link (_tmp8_);
#line 114 "Deepin/DeepinBlurEffect.vala"
	_tmp9_ = self->priv->program;
#line 114 "Deepin/DeepinBlurEffect.vala"
	uniform_no = cogl_program_get_uniform_location (_tmp9_, "texture");
#line 115 "Deepin/DeepinBlurEffect.vala"
	_tmp10_ = self->priv->program;
#line 115 "Deepin/DeepinBlurEffect.vala"
	cogl_program_set_uniform_1i (_tmp10_, uniform_no, 0);
#line 116 "Deepin/DeepinBlurEffect.vala"
	_tmp11_ = self->priv->program;
#line 116 "Deepin/DeepinBlurEffect.vala"
	uniform_no = cogl_program_get_uniform_location (_tmp11_, "width");
#line 117 "Deepin/DeepinBlurEffect.vala"
	_tmp12_ = self->priv->program;
#line 117 "Deepin/DeepinBlurEffect.vala"
	_tmp13_ = self->priv->_width;
#line 117 "Deepin/DeepinBlurEffect.vala"
	cogl_program_set_uniform_1i (_tmp12_, uniform_no, _tmp13_);
#line 118 "Deepin/DeepinBlurEffect.vala"
	_tmp14_ = self->priv->program;
#line 118 "Deepin/DeepinBlurEffect.vala"
	uniform_no = cogl_program_get_uniform_location (_tmp14_, "height");
#line 119 "Deepin/DeepinBlurEffect.vala"
	_tmp15_ = self->priv->program;
#line 119 "Deepin/DeepinBlurEffect.vala"
	_tmp16_ = self->priv->_height;
#line 119 "Deepin/DeepinBlurEffect.vala"
	cogl_program_set_uniform_1i (_tmp15_, uniform_no, _tmp16_);
#line 120 "Deepin/DeepinBlurEffect.vala"
	_tmp17_ = self->priv->program;
#line 120 "Deepin/DeepinBlurEffect.vala"
	uniform_no = cogl_program_get_uniform_location (_tmp17_, "radius");
#line 121 "Deepin/DeepinBlurEffect.vala"
	_tmp18_ = self->priv->program;
#line 121 "Deepin/DeepinBlurEffect.vala"
	_tmp19_ = self->priv->_radius;
#line 121 "Deepin/DeepinBlurEffect.vala"
	cogl_program_set_uniform_1f (_tmp18_, uniform_no, _tmp19_);
#line 122 "Deepin/DeepinBlurEffect.vala"
	_tmp20_ = self->priv->program;
#line 122 "Deepin/DeepinBlurEffect.vala"
	uniform_no = cogl_program_get_uniform_location (_tmp20_, "bloom");
#line 123 "Deepin/DeepinBlurEffect.vala"
	_tmp21_ = self->priv->program;
#line 123 "Deepin/DeepinBlurEffect.vala"
	_tmp22_ = self->priv->_bloom;
#line 123 "Deepin/DeepinBlurEffect.vala"
	cogl_program_set_uniform_1f (_tmp21_, uniform_no, _tmp22_);
#line 98 "Deepin/DeepinBlurEffect.vala"
	_cogl_shader_unref0 (shader);
#line 98 "Deepin/DeepinBlurEffect.vala"
	return obj;
#line 595 "DeepinBlurEffect.c"
}

static void
gala_deepin_blur_effect_class_init (GalaDeepinBlurEffectClass * klass,
                                    gpointer klass_data)
{
#line 83 "Deepin/DeepinBlurEffect.vala"
	gala_deepin_blur_effect_parent_class = g_type_class_peek_parent (klass);
#line 83 "Deepin/DeepinBlurEffect.vala"
	g_type_class_adjust_private_offset (klass, &GalaDeepinBlurEffect_private_offset);
#line 83 "Deepin/DeepinBlurEffect.vala"
	((ClutterOffscreenEffectClass *) klass)->paint_target = (void (*) (ClutterOffscreenEffect*)) gala_deepin_blur_effect_real_paint_target;
#line 83 "Deepin/DeepinBlurEffect.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_deepin_blur_effect_get_property;
#line 83 "Deepin/DeepinBlurEffect.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_deepin_blur_effect_set_property;
#line 83 "Deepin/DeepinBlurEffect.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_deepin_blur_effect_constructor;
#line 83 "Deepin/DeepinBlurEffect.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_deepin_blur_effect_finalize;
#line 83 "Deepin/DeepinBlurEffect.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DEEPIN_BLUR_EFFECT_HORIZONTAL_PROPERTY, gala_deepin_blur_effect_properties[GALA_DEEPIN_BLUR_EFFECT_HORIZONTAL_PROPERTY] = g_param_spec_boolean ("horizontal", "horizontal", "horizontal", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 83 "Deepin/DeepinBlurEffect.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DEEPIN_BLUR_EFFECT_WIDTH_PROPERTY, gala_deepin_blur_effect_properties[GALA_DEEPIN_BLUR_EFFECT_WIDTH_PROPERTY] = g_param_spec_int ("width", "width", "width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 83 "Deepin/DeepinBlurEffect.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DEEPIN_BLUR_EFFECT_HEIGHT_PROPERTY, gala_deepin_blur_effect_properties[GALA_DEEPIN_BLUR_EFFECT_HEIGHT_PROPERTY] = g_param_spec_int ("height", "height", "height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 83 "Deepin/DeepinBlurEffect.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DEEPIN_BLUR_EFFECT_RADIUS_PROPERTY, gala_deepin_blur_effect_properties[GALA_DEEPIN_BLUR_EFFECT_RADIUS_PROPERTY] = g_param_spec_float ("radius", "radius", "radius", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 83 "Deepin/DeepinBlurEffect.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DEEPIN_BLUR_EFFECT_BLOOM_PROPERTY, gala_deepin_blur_effect_properties[GALA_DEEPIN_BLUR_EFFECT_BLOOM_PROPERTY] = g_param_spec_float ("bloom", "bloom", "bloom", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 626 "DeepinBlurEffect.c"
}

static void
gala_deepin_blur_effect_instance_init (GalaDeepinBlurEffect * self,
                                       gpointer klass)
{
#line 83 "Deepin/DeepinBlurEffect.vala"
	self->priv = gala_deepin_blur_effect_get_instance_private (self);
#line 635 "DeepinBlurEffect.c"
}

static void
gala_deepin_blur_effect_finalize (GObject * obj)
{
	GalaDeepinBlurEffect * self;
#line 83 "Deepin/DeepinBlurEffect.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_DEEPIN_BLUR_EFFECT, GalaDeepinBlurEffect);
#line 91 "Deepin/DeepinBlurEffect.vala"
	_cogl_program_unref0 (self->priv->program);
#line 83 "Deepin/DeepinBlurEffect.vala"
	G_OBJECT_CLASS (gala_deepin_blur_effect_parent_class)->finalize (obj);
#line 648 "DeepinBlurEffect.c"
}

GType
gala_deepin_blur_effect_get_type (void)
{
	static volatile gsize gala_deepin_blur_effect_type_id__volatile = 0;
	if (g_once_init_enter (&gala_deepin_blur_effect_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaDeepinBlurEffectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_deepin_blur_effect_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaDeepinBlurEffect), 0, (GInstanceInitFunc) gala_deepin_blur_effect_instance_init, NULL };
		GType gala_deepin_blur_effect_type_id;
		gala_deepin_blur_effect_type_id = g_type_register_static (clutter_offscreen_effect_get_type (), "GalaDeepinBlurEffect", &g_define_type_info, 0);
		GalaDeepinBlurEffect_private_offset = g_type_add_instance_private (gala_deepin_blur_effect_type_id, sizeof (GalaDeepinBlurEffectPrivate));
		g_once_init_leave (&gala_deepin_blur_effect_type_id__volatile, gala_deepin_blur_effect_type_id);
	}
	return gala_deepin_blur_effect_type_id__volatile;
}

static void
_vala_gala_deepin_blur_effect_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	GalaDeepinBlurEffect * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_DEEPIN_BLUR_EFFECT, GalaDeepinBlurEffect);
#line 83 "Deepin/DeepinBlurEffect.vala"
	switch (property_id) {
#line 83 "Deepin/DeepinBlurEffect.vala"
		case GALA_DEEPIN_BLUR_EFFECT_HORIZONTAL_PROPERTY:
#line 83 "Deepin/DeepinBlurEffect.vala"
		g_value_set_boolean (value, gala_deepin_blur_effect_get_horizontal (self));
#line 83 "Deepin/DeepinBlurEffect.vala"
		break;
#line 83 "Deepin/DeepinBlurEffect.vala"
		case GALA_DEEPIN_BLUR_EFFECT_WIDTH_PROPERTY:
#line 83 "Deepin/DeepinBlurEffect.vala"
		g_value_set_int (value, gala_deepin_blur_effect_get_width (self));
#line 83 "Deepin/DeepinBlurEffect.vala"
		break;
#line 83 "Deepin/DeepinBlurEffect.vala"
		case GALA_DEEPIN_BLUR_EFFECT_HEIGHT_PROPERTY:
#line 83 "Deepin/DeepinBlurEffect.vala"
		g_value_set_int (value, gala_deepin_blur_effect_get_height (self));
#line 83 "Deepin/DeepinBlurEffect.vala"
		break;
#line 83 "Deepin/DeepinBlurEffect.vala"
		case GALA_DEEPIN_BLUR_EFFECT_RADIUS_PROPERTY:
#line 83 "Deepin/DeepinBlurEffect.vala"
		g_value_set_float (value, gala_deepin_blur_effect_get_radius (self));
#line 83 "Deepin/DeepinBlurEffect.vala"
		break;
#line 83 "Deepin/DeepinBlurEffect.vala"
		case GALA_DEEPIN_BLUR_EFFECT_BLOOM_PROPERTY:
#line 83 "Deepin/DeepinBlurEffect.vala"
		g_value_set_float (value, gala_deepin_blur_effect_get_bloom (self));
#line 83 "Deepin/DeepinBlurEffect.vala"
		break;
#line 705 "DeepinBlurEffect.c"
		default:
#line 83 "Deepin/DeepinBlurEffect.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 83 "Deepin/DeepinBlurEffect.vala"
		break;
#line 711 "DeepinBlurEffect.c"
	}
}

static void
_vala_gala_deepin_blur_effect_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	GalaDeepinBlurEffect * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_DEEPIN_BLUR_EFFECT, GalaDeepinBlurEffect);
#line 83 "Deepin/DeepinBlurEffect.vala"
	switch (property_id) {
#line 83 "Deepin/DeepinBlurEffect.vala"
		case GALA_DEEPIN_BLUR_EFFECT_HORIZONTAL_PROPERTY:
#line 83 "Deepin/DeepinBlurEffect.vala"
		gala_deepin_blur_effect_set_horizontal (self, g_value_get_boolean (value));
#line 83 "Deepin/DeepinBlurEffect.vala"
		break;
#line 83 "Deepin/DeepinBlurEffect.vala"
		case GALA_DEEPIN_BLUR_EFFECT_WIDTH_PROPERTY:
#line 83 "Deepin/DeepinBlurEffect.vala"
		gala_deepin_blur_effect_set_width (self, g_value_get_int (value));
#line 83 "Deepin/DeepinBlurEffect.vala"
		break;
#line 83 "Deepin/DeepinBlurEffect.vala"
		case GALA_DEEPIN_BLUR_EFFECT_HEIGHT_PROPERTY:
#line 83 "Deepin/DeepinBlurEffect.vala"
		gala_deepin_blur_effect_set_height (self, g_value_get_int (value));
#line 83 "Deepin/DeepinBlurEffect.vala"
		break;
#line 83 "Deepin/DeepinBlurEffect.vala"
		case GALA_DEEPIN_BLUR_EFFECT_RADIUS_PROPERTY:
#line 83 "Deepin/DeepinBlurEffect.vala"
		gala_deepin_blur_effect_set_radius (self, g_value_get_float (value));
#line 83 "Deepin/DeepinBlurEffect.vala"
		break;
#line 83 "Deepin/DeepinBlurEffect.vala"
		case GALA_DEEPIN_BLUR_EFFECT_BLOOM_PROPERTY:
#line 83 "Deepin/DeepinBlurEffect.vala"
		gala_deepin_blur_effect_set_bloom (self, g_value_get_float (value));
#line 83 "Deepin/DeepinBlurEffect.vala"
		break;
#line 755 "DeepinBlurEffect.c"
		default:
#line 83 "Deepin/DeepinBlurEffect.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 83 "Deepin/DeepinBlurEffect.vala"
		break;
#line 761 "DeepinBlurEffect.c"
	}
}

