/* DragDropAction.c generated by valac 0.43.91, the Vala compiler
 * generated from DragDropAction.vala, do not modify */

/**/
/*  Copyright (C) 2015 Deepin Technology Co., Ltd.*/
/*  Copyright (C) 2013 Tom Beckmann*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib-object.h>
#include <clutter/clutter.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>

typedef enum  {
	GALA_DRAG_DROP_ACTION_TYPE_SOURCE = 0,
	GALA_DRAG_DROP_ACTION_TYPE_DESTINATION
} GalaDragDropActionType;

#define GALA_TYPE_DRAG_DROP_ACTION_TYPE (gala_drag_drop_action_type_get_type ())
typedef enum  {
	GALA_DRAG_DROP_ACTION_DIRECTION_NONE = 0,
	GALA_DRAG_DROP_ACTION_DIRECTION_LEFT = 1,
	GALA_DRAG_DROP_ACTION_DIRECTION_RIGHT = 1 << 1,
	GALA_DRAG_DROP_ACTION_DIRECTION_UP = 1 << 2,
	GALA_DRAG_DROP_ACTION_DIRECTION_DOWN = 1 << 3,
	GALA_DRAG_DROP_ACTION_DIRECTION_ALL = ((GALA_DRAG_DROP_ACTION_DIRECTION_LEFT + GALA_DRAG_DROP_ACTION_DIRECTION_RIGHT) + GALA_DRAG_DROP_ACTION_DIRECTION_UP) + GALA_DRAG_DROP_ACTION_DIRECTION_DOWN
} GalaDragDropActionDirection;

#define GALA_TYPE_DRAG_DROP_ACTION_DIRECTION (gala_drag_drop_action_direction_get_type ())

#define GALA_TYPE_DRAG_DROP_ACTION (gala_drag_drop_action_get_type ())
#define GALA_DRAG_DROP_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction))
#define GALA_DRAG_DROP_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropActionClass))
#define GALA_IS_DRAG_DROP_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_DRAG_DROP_ACTION))
#define GALA_IS_DRAG_DROP_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_DRAG_DROP_ACTION))
#define GALA_DRAG_DROP_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropActionClass))

typedef struct _GalaDragDropAction GalaDragDropAction;
typedef struct _GalaDragDropActionClass GalaDragDropActionClass;
typedef struct _GalaDragDropActionPrivate GalaDragDropActionPrivate;
enum  {
	GALA_DRAG_DROP_ACTION_0_PROPERTY,
	GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY,
	GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY,
	GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY,
	GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY,
	GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY,
	GALA_DRAG_DROP_ACTION_NUM_PROPERTIES
};
static GParamSpec* gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_ClutterPoint_free0(var) ((var == NULL) ? NULL : (var = (_vala_ClutterPoint_free (var), NULL)))
enum  {
	GALA_DRAG_DROP_ACTION_DRAG_BEGIN_SIGNAL,
	GALA_DRAG_DROP_ACTION_DRAG_CANCELED_SIGNAL,
	GALA_DRAG_DROP_ACTION_DRAG_END_SIGNAL,
	GALA_DRAG_DROP_ACTION_DRAG_MOTION_SIGNAL,
	GALA_DRAG_DROP_ACTION_CROSSED_SIGNAL,
	GALA_DRAG_DROP_ACTION_DESTINATION_CROSSED_SIGNAL,
	GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL,
	GALA_DRAG_DROP_ACTION_NUM_SIGNALS
};
static guint gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_NUM_SIGNALS] = {0};

struct _GalaDragDropAction {
	ClutterAction parent_instance;
	GalaDragDropActionPrivate * priv;
	GalaDragDropActionDirection allow_direction;
	gfloat allow_y_overflow;
};

struct _GalaDragDropActionClass {
	ClutterActionClass parent_class;
};

struct _GalaDragDropActionPrivate {
	GalaDragDropActionType _drag_type;
	gchar* _drag_id;
	ClutterActor* _handle;
	gboolean _dragging;
	gboolean _allow_bubbling;
	ClutterActor* hovered;
	gboolean clicked;
	gfloat orig_x;
	gfloat orig_y;
	ClutterPoint* offset;
	gfloat last_x;
	gfloat last_y;
};

static gint GalaDragDropAction_private_offset;
static gpointer gala_drag_drop_action_parent_class = NULL;
static GeeHashMap* gala_drag_drop_action_sources;
static GeeHashMap* gala_drag_drop_action_sources = NULL;

GType gala_drag_drop_action_type_get_type (void) G_GNUC_CONST;
GType gala_drag_drop_action_direction_get_type (void) G_GNUC_CONST;
GType gala_drag_drop_action_get_type (void) G_GNUC_CONST;
static void gala_drag_drop_action_release_actor (GalaDragDropAction* self,
                                          ClutterActor* actor);
static void _vala_ClutterPoint_free (ClutterPoint* self);
GalaDragDropAction* gala_drag_drop_action_new (GalaDragDropActionType type,
                                               const gchar* id);
GalaDragDropAction* gala_drag_drop_action_construct (GType object_type,
                                                     GalaDragDropActionType type,
                                                     const gchar* id);
static void gala_drag_drop_action_real_set_actor (ClutterActorMeta* base,
                                           ClutterActor* new_actor);
static void gala_drag_drop_action_connect_actor (GalaDragDropAction* self,
                                          ClutterActor* actor);
GalaDragDropActionType gala_drag_drop_action_get_drag_type (GalaDragDropAction* self);
static gboolean gala_drag_drop_action_source_clicked (GalaDragDropAction* self,
                                               ClutterButtonEvent* event);
static gboolean _gala_drag_drop_action_source_clicked_clutter_actor_button_press_event (ClutterActor* _sender,
                                                                                 ClutterButtonEvent* event,
                                                                                 gpointer self);
const gchar* gala_drag_drop_action_get_drag_id (GalaDragDropAction* self);
static void gala_drag_drop_action_emit_crossed (GalaDragDropAction* self,
                                         ClutterActor* destination,
                                         gboolean hovered);
static GalaDragDropAction* gala_drag_drop_action_get_drag_drop_action (GalaDragDropAction* self,
                                                                ClutterActor* actor);
static gboolean gala_drag_drop_action_follow_move (GalaDragDropAction* self,
                                            ClutterEvent* event);
static gboolean _gala_drag_drop_action_follow_move_clutter_actor_captured_event (ClutterActor* _sender,
                                                                          ClutterEvent* event,
                                                                          gpointer self);
static gboolean gala_drag_drop_action_drag_allowed (GalaDragDropAction* self,
                                             ClutterEvent* event);
gboolean gala_drag_drop_action_get_dragging (GalaDragDropAction* self);
static void gala_drag_drop_action_set_handle (GalaDragDropAction* self,
                                       ClutterActor* value);
ClutterActor* gala_drag_drop_action_get_handle (GalaDragDropAction* self);
static ClutterPoint* _vala_ClutterPoint_copy (ClutterPoint* self);
static void gala_drag_drop_action_set_dragging (GalaDragDropAction* self,
                                         gboolean value);
void gala_drag_drop_action_cancel (GalaDragDropAction* self);
gboolean gala_drag_drop_action_get_allow_bubbling (GalaDragDropAction* self);
static void gala_drag_drop_action_finish (GalaDragDropAction* self);
static void gala_drag_drop_action_cleanup (GalaDragDropAction* self);
void gala_drag_drop_action_cancel_all_by_id (const gchar* id);
static void gala_drag_drop_action_set_drag_type (GalaDragDropAction* self,
                                          GalaDragDropActionType value);
static void gala_drag_drop_action_set_drag_id (GalaDragDropAction* self,
                                        const gchar* value);
void gala_drag_drop_action_set_allow_bubbling (GalaDragDropAction* self,
                                               gboolean value);
static void g_cclosure_user_marshal_OBJECT__FLOAT_FLOAT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__FLOAT_FLOAT (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void gala_drag_drop_action_finalize (GObject * obj);
static void _vala_gala_drag_drop_action_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_gala_drag_drop_action_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);

GType
gala_drag_drop_action_type_get_type (void)
{
	static volatile gsize gala_drag_drop_action_type_type_id__volatile = 0;
	if (g_once_init_enter (&gala_drag_drop_action_type_type_id__volatile)) {
		static const GEnumValue values[] = {{GALA_DRAG_DROP_ACTION_TYPE_SOURCE, "GALA_DRAG_DROP_ACTION_TYPE_SOURCE", "source"}, {GALA_DRAG_DROP_ACTION_TYPE_DESTINATION, "GALA_DRAG_DROP_ACTION_TYPE_DESTINATION", "destination"}, {0, NULL, NULL}};
		GType gala_drag_drop_action_type_type_id;
		gala_drag_drop_action_type_type_id = g_enum_register_static ("GalaDragDropActionType", values);
		g_once_init_leave (&gala_drag_drop_action_type_type_id__volatile, gala_drag_drop_action_type_type_id);
	}
	return gala_drag_drop_action_type_type_id__volatile;
}

GType
gala_drag_drop_action_direction_get_type (void)
{
	static volatile gsize gala_drag_drop_action_direction_type_id__volatile = 0;
	if (g_once_init_enter (&gala_drag_drop_action_direction_type_id__volatile)) {
		static const GEnumValue values[] = {{GALA_DRAG_DROP_ACTION_DIRECTION_NONE, "GALA_DRAG_DROP_ACTION_DIRECTION_NONE", "none"}, {GALA_DRAG_DROP_ACTION_DIRECTION_LEFT, "GALA_DRAG_DROP_ACTION_DIRECTION_LEFT", "left"}, {GALA_DRAG_DROP_ACTION_DIRECTION_RIGHT, "GALA_DRAG_DROP_ACTION_DIRECTION_RIGHT", "right"}, {GALA_DRAG_DROP_ACTION_DIRECTION_UP, "GALA_DRAG_DROP_ACTION_DIRECTION_UP", "up"}, {GALA_DRAG_DROP_ACTION_DIRECTION_DOWN, "GALA_DRAG_DROP_ACTION_DIRECTION_DOWN", "down"}, {GALA_DRAG_DROP_ACTION_DIRECTION_ALL, "GALA_DRAG_DROP_ACTION_DIRECTION_ALL", "all"}, {0, NULL, NULL}};
		GType gala_drag_drop_action_direction_type_id;
		gala_drag_drop_action_direction_type_id = g_enum_register_static ("GalaDragDropActionDirection", values);
		g_once_init_leave (&gala_drag_drop_action_direction_type_id__volatile, gala_drag_drop_action_direction_type_id);
	}
	return gala_drag_drop_action_direction_type_id__volatile;
}

static inline gpointer
gala_drag_drop_action_get_instance_private (GalaDragDropAction* self)
{
	return G_STRUCT_MEMBER_P (self, GalaDragDropAction_private_offset);
}

static void
_vala_ClutterPoint_free (ClutterPoint* self)
{
#line 138 "DragDropAction.vala"
	g_boxed_free (clutter_point_get_type (), self);
#line 232 "DragDropAction.c"
}

/**
 * Create a new DragDropAction
 *
 * @param type The type of this actor
 * @param id   An ID that marks which sources can be dragged on
 *             which destinations. It has to be the same for all actors that
 *             should be compatible with each other.
 */
GalaDragDropAction*
gala_drag_drop_action_construct (GType object_type,
                                 GalaDragDropActionType type,
                                 const gchar* id)
{
	GalaDragDropAction * self = NULL;
	GeeHashMap* _tmp0_;
#line 150 "DragDropAction.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 152 "DragDropAction.vala"
	self = (GalaDragDropAction*) g_object_new (object_type, "drag-type", type, "drag-id", id, NULL);
#line 154 "DragDropAction.vala"
	_tmp0_ = gala_drag_drop_action_sources;
#line 154 "DragDropAction.vala"
	if (_tmp0_ == NULL) {
#line 258 "DragDropAction.c"
		GeeHashMap* _tmp1_;
#line 155 "DragDropAction.vala"
		_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_LINKED_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 155 "DragDropAction.vala"
		_g_object_unref0 (gala_drag_drop_action_sources);
#line 155 "DragDropAction.vala"
		gala_drag_drop_action_sources = _tmp1_;
#line 266 "DragDropAction.c"
	}
#line 150 "DragDropAction.vala"
	return self;
#line 270 "DragDropAction.c"
}

GalaDragDropAction*
gala_drag_drop_action_new (GalaDragDropActionType type,
                           const gchar* id)
{
#line 150 "DragDropAction.vala"
	return gala_drag_drop_action_construct (GALA_TYPE_DRAG_DROP_ACTION, type, id);
#line 279 "DragDropAction.c"
}

static void
gala_drag_drop_action_real_set_actor (ClutterActorMeta* base,
                                      ClutterActor* new_actor)
{
	GalaDragDropAction * self;
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
#line 164 "DragDropAction.vala"
	self = (GalaDragDropAction*) base;
#line 166 "DragDropAction.vala"
	_tmp0_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 166 "DragDropAction.vala"
	_tmp1_ = _tmp0_;
#line 166 "DragDropAction.vala"
	if (_tmp1_ != NULL) {
#line 297 "DragDropAction.c"
		ClutterActor* _tmp2_;
		ClutterActor* _tmp3_;
#line 167 "DragDropAction.vala"
		_tmp2_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 167 "DragDropAction.vala"
		_tmp3_ = _tmp2_;
#line 167 "DragDropAction.vala"
		gala_drag_drop_action_release_actor (self, _tmp3_);
#line 306 "DragDropAction.c"
	}
#line 170 "DragDropAction.vala"
	if (new_actor != NULL) {
#line 171 "DragDropAction.vala"
		gala_drag_drop_action_connect_actor (self, new_actor);
#line 312 "DragDropAction.c"
	}
#line 174 "DragDropAction.vala"
	CLUTTER_ACTOR_META_CLASS (gala_drag_drop_action_parent_class)->set_actor ((ClutterActorMeta*) G_TYPE_CHECK_INSTANCE_CAST (self, clutter_action_get_type (), ClutterAction), new_actor);
#line 316 "DragDropAction.c"
}

static gboolean
_gala_drag_drop_action_source_clicked_clutter_actor_button_press_event (ClutterActor* _sender,
                                                                        ClutterButtonEvent* event,
                                                                        gpointer self)
{
	gboolean result;
	result = gala_drag_drop_action_source_clicked ((GalaDragDropAction*) self, event);
#line 180 "DragDropAction.vala"
	return result;
#line 328 "DragDropAction.c"
}

static void
gala_drag_drop_action_release_actor (GalaDragDropAction* self,
                                     ClutterActor* actor)
{
	GalaDragDropActionType _tmp0_;
#line 177 "DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 177 "DragDropAction.vala"
	g_return_if_fail (actor != NULL);
#line 179 "DragDropAction.vala"
	_tmp0_ = self->priv->_drag_type;
#line 179 "DragDropAction.vala"
	if (_tmp0_ == GALA_DRAG_DROP_ACTION_TYPE_SOURCE) {
#line 344 "DragDropAction.c"
		guint _tmp1_;
		GeeLinkedList* source_list = NULL;
		GeeHashMap* _tmp2_;
		const gchar* _tmp3_;
		gpointer _tmp4_;
		GeeLinkedList* _tmp5_;
#line 180 "DragDropAction.vala"
		g_signal_parse_name ("button-press-event", clutter_actor_get_type (), &_tmp1_, NULL, FALSE);
#line 180 "DragDropAction.vala"
		g_signal_handlers_disconnect_matched (actor, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _gala_drag_drop_action_source_clicked_clutter_actor_button_press_event, self);
#line 182 "DragDropAction.vala"
		_tmp2_ = gala_drag_drop_action_sources;
#line 182 "DragDropAction.vala"
		_tmp3_ = self->priv->_drag_id;
#line 182 "DragDropAction.vala"
		_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, _tmp3_);
#line 182 "DragDropAction.vala"
		source_list = (GeeLinkedList*) _tmp4_;
#line 183 "DragDropAction.vala"
		_tmp5_ = source_list;
#line 183 "DragDropAction.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp5_, actor);
#line 179 "DragDropAction.vala"
		_g_object_unref0 (source_list);
#line 369 "DragDropAction.c"
	}
}

static void
gala_drag_drop_action_connect_actor (GalaDragDropAction* self,
                                     ClutterActor* actor)
{
	GalaDragDropActionType _tmp0_;
#line 187 "DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 187 "DragDropAction.vala"
	g_return_if_fail (actor != NULL);
#line 189 "DragDropAction.vala"
	_tmp0_ = self->priv->_drag_type;
#line 189 "DragDropAction.vala"
	if (_tmp0_ == GALA_DRAG_DROP_ACTION_TYPE_SOURCE) {
#line 386 "DragDropAction.c"
		GeeLinkedList* source_list = NULL;
		GeeHashMap* _tmp1_;
		const gchar* _tmp2_;
		gpointer _tmp3_;
		GeeLinkedList* _tmp4_;
		GeeLinkedList* _tmp9_;
#line 190 "DragDropAction.vala"
		g_signal_connect_object (actor, "button-press-event", (GCallback) _gala_drag_drop_action_source_clicked_clutter_actor_button_press_event, self, 0);
#line 192 "DragDropAction.vala"
		_tmp1_ = gala_drag_drop_action_sources;
#line 192 "DragDropAction.vala"
		_tmp2_ = self->priv->_drag_id;
#line 192 "DragDropAction.vala"
		_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, _tmp2_);
#line 192 "DragDropAction.vala"
		source_list = (GeeLinkedList*) _tmp3_;
#line 193 "DragDropAction.vala"
		_tmp4_ = source_list;
#line 193 "DragDropAction.vala"
		if (_tmp4_ == NULL) {
#line 407 "DragDropAction.c"
			GeeLinkedList* _tmp5_;
			GeeHashMap* _tmp6_;
			const gchar* _tmp7_;
			GeeLinkedList* _tmp8_;
#line 194 "DragDropAction.vala"
			_tmp5_ = gee_linked_list_new (clutter_actor_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 194 "DragDropAction.vala"
			_g_object_unref0 (source_list);
#line 194 "DragDropAction.vala"
			source_list = _tmp5_;
#line 195 "DragDropAction.vala"
			_tmp6_ = gala_drag_drop_action_sources;
#line 195 "DragDropAction.vala"
			_tmp7_ = self->priv->_drag_id;
#line 195 "DragDropAction.vala"
			_tmp8_ = source_list;
#line 195 "DragDropAction.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp7_, _tmp8_);
#line 426 "DragDropAction.c"
		}
#line 198 "DragDropAction.vala"
		_tmp9_ = source_list;
#line 198 "DragDropAction.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, actor);
#line 189 "DragDropAction.vala"
		_g_object_unref0 (source_list);
#line 434 "DragDropAction.c"
	}
}

static void
gala_drag_drop_action_emit_crossed (GalaDragDropAction* self,
                                    ClutterActor* destination,
                                    gboolean hovered)
{
	GalaDragDropAction* _tmp0_;
	GalaDragDropAction* _tmp1_;
#line 202 "DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 202 "DragDropAction.vala"
	g_return_if_fail (destination != NULL);
#line 204 "DragDropAction.vala"
	_tmp0_ = gala_drag_drop_action_get_drag_drop_action (self, destination);
#line 204 "DragDropAction.vala"
	_tmp1_ = _tmp0_;
#line 204 "DragDropAction.vala"
	g_signal_emit (_tmp1_, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_CROSSED_SIGNAL], 0, hovered);
#line 204 "DragDropAction.vala"
	_g_object_unref0 (_tmp1_);
#line 205 "DragDropAction.vala"
	g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DESTINATION_CROSSED_SIGNAL], 0, destination, hovered);
#line 459 "DragDropAction.c"
}

static gboolean
_gala_drag_drop_action_follow_move_clutter_actor_captured_event (ClutterActor* _sender,
                                                                 ClutterEvent* event,
                                                                 gpointer self)
{
	gboolean result;
	result = gala_drag_drop_action_follow_move ((GalaDragDropAction*) self, event);
#line 215 "DragDropAction.vala"
	return result;
#line 471 "DragDropAction.c"
}

static gboolean
gala_drag_drop_action_source_clicked (GalaDragDropAction* self,
                                      ClutterButtonEvent* event)
{
	gboolean result = FALSE;
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	ClutterStage* _tmp2_;
#line 208 "DragDropAction.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 208 "DragDropAction.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 210 "DragDropAction.vala"
	if (event->button != ((guint32) 1)) {
#line 211 "DragDropAction.vala"
		g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL], 0, event->button);
#line 212 "DragDropAction.vala"
		result = FALSE;
#line 212 "DragDropAction.vala"
		return result;
#line 494 "DragDropAction.c"
	}
#line 215 "DragDropAction.vala"
	_tmp0_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 215 "DragDropAction.vala"
	_tmp1_ = _tmp0_;
#line 215 "DragDropAction.vala"
	_tmp2_ = clutter_actor_get_stage (_tmp1_);
#line 215 "DragDropAction.vala"
	g_signal_connect_object ((ClutterActor*) _tmp2_, "captured-event", (GCallback) _gala_drag_drop_action_follow_move_clutter_actor_captured_event, self, 0);
#line 216 "DragDropAction.vala"
	self->priv->clicked = TRUE;
#line 217 "DragDropAction.vala"
	self->priv->last_x = event->x;
#line 218 "DragDropAction.vala"
	self->priv->last_y = event->y;
#line 220 "DragDropAction.vala"
	result = TRUE;
#line 220 "DragDropAction.vala"
	return result;
#line 514 "DragDropAction.c"
}

static gboolean
gala_drag_drop_action_drag_allowed (GalaDragDropAction* self,
                                    ClutterEvent* event)
{
	gboolean result = FALSE;
	gfloat x = 0.0F;
	gfloat y = 0.0F;
	gfloat _tmp0_ = 0.0F;
	gfloat _tmp1_ = 0.0F;
	gint drag_threshold = 0;
	ClutterSettings* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_ = FALSE;
	GalaDragDropActionDirection _tmp6_;
	gboolean _tmp7_ = FALSE;
	GalaDragDropActionDirection _tmp8_;
	gboolean _tmp9_ = FALSE;
	GalaDragDropActionDirection _tmp10_;
	gboolean _tmp11_ = FALSE;
	GalaDragDropActionDirection _tmp12_;
#line 223 "DragDropAction.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 223 "DragDropAction.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 226 "DragDropAction.vala"
	clutter_event_get_coords (event, &_tmp0_, &_tmp1_);
#line 226 "DragDropAction.vala"
	x = _tmp0_;
#line 226 "DragDropAction.vala"
	y = _tmp1_;
#line 228 "DragDropAction.vala"
	_tmp2_ = clutter_settings_get_default ();
#line 228 "DragDropAction.vala"
	g_object_get (_tmp2_, "dnd-drag-threshold", &_tmp3_, NULL);
#line 228 "DragDropAction.vala"
	_tmp4_ = _tmp3_;
#line 228 "DragDropAction.vala"
	drag_threshold = _tmp4_;
#line 230 "DragDropAction.vala"
	_tmp6_ = self->allow_direction;
#line 230 "DragDropAction.vala"
	if ((_tmp6_ & GALA_DRAG_DROP_ACTION_DIRECTION_LEFT) == GALA_DRAG_DROP_ACTION_DIRECTION_LEFT) {
#line 231 "DragDropAction.vala"
		_tmp5_ = (self->priv->last_x - x) > ((gfloat) drag_threshold);
#line 562 "DragDropAction.c"
	} else {
#line 230 "DragDropAction.vala"
		_tmp5_ = FALSE;
#line 566 "DragDropAction.c"
	}
#line 230 "DragDropAction.vala"
	if (_tmp5_) {
#line 232 "DragDropAction.vala"
		result = TRUE;
#line 232 "DragDropAction.vala"
		return result;
#line 574 "DragDropAction.c"
	}
#line 235 "DragDropAction.vala"
	_tmp8_ = self->allow_direction;
#line 235 "DragDropAction.vala"
	if ((_tmp8_ & GALA_DRAG_DROP_ACTION_DIRECTION_RIGHT) == GALA_DRAG_DROP_ACTION_DIRECTION_RIGHT) {
#line 236 "DragDropAction.vala"
		_tmp7_ = (x - self->priv->last_x) > ((gfloat) drag_threshold);
#line 582 "DragDropAction.c"
	} else {
#line 235 "DragDropAction.vala"
		_tmp7_ = FALSE;
#line 586 "DragDropAction.c"
	}
#line 235 "DragDropAction.vala"
	if (_tmp7_) {
#line 237 "DragDropAction.vala"
		result = TRUE;
#line 237 "DragDropAction.vala"
		return result;
#line 594 "DragDropAction.c"
	}
#line 240 "DragDropAction.vala"
	_tmp10_ = self->allow_direction;
#line 240 "DragDropAction.vala"
	if ((_tmp10_ & GALA_DRAG_DROP_ACTION_DIRECTION_UP) == GALA_DRAG_DROP_ACTION_DIRECTION_UP) {
#line 241 "DragDropAction.vala"
		_tmp9_ = (self->priv->last_y - y) > ((gfloat) drag_threshold);
#line 602 "DragDropAction.c"
	} else {
#line 240 "DragDropAction.vala"
		_tmp9_ = FALSE;
#line 606 "DragDropAction.c"
	}
#line 240 "DragDropAction.vala"
	if (_tmp9_) {
#line 242 "DragDropAction.vala"
		result = TRUE;
#line 242 "DragDropAction.vala"
		return result;
#line 614 "DragDropAction.c"
	}
#line 245 "DragDropAction.vala"
	_tmp12_ = self->allow_direction;
#line 245 "DragDropAction.vala"
	if ((_tmp12_ & GALA_DRAG_DROP_ACTION_DIRECTION_DOWN) == GALA_DRAG_DROP_ACTION_DIRECTION_DOWN) {
#line 246 "DragDropAction.vala"
		_tmp11_ = (y - self->priv->last_y) > ((gfloat) drag_threshold);
#line 622 "DragDropAction.c"
	} else {
#line 245 "DragDropAction.vala"
		_tmp11_ = FALSE;
#line 626 "DragDropAction.c"
	}
#line 245 "DragDropAction.vala"
	if (_tmp11_) {
#line 247 "DragDropAction.vala"
		result = TRUE;
#line 247 "DragDropAction.vala"
		return result;
#line 634 "DragDropAction.c"
	}
#line 250 "DragDropAction.vala"
	if (fabsf (y - self->priv->last_y) < self->allow_y_overflow) {
#line 251 "DragDropAction.vala"
		result = TRUE;
#line 251 "DragDropAction.vala"
		return result;
#line 642 "DragDropAction.c"
	}
#line 254 "DragDropAction.vala"
	result = FALSE;
#line 254 "DragDropAction.vala"
	return result;
#line 648 "DragDropAction.c"
}

static ClutterPoint*
_vala_ClutterPoint_copy (ClutterPoint* self)
{
#line 283 "DragDropAction.vala"
	return g_boxed_copy (clutter_point_get_type (), self);
#line 656 "DragDropAction.c"
}

static gpointer
__vala_ClutterPoint_copy0 (gpointer self)
{
#line 283 "DragDropAction.vala"
	return self ? _vala_ClutterPoint_copy (self) : NULL;
#line 664 "DragDropAction.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 294 "DragDropAction.vala"
	return self ? g_object_ref (self) : NULL;
#line 672 "DragDropAction.c"
}

static gboolean
gala_drag_drop_action_follow_move (GalaDragDropAction* self,
                                   ClutterEvent* event)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 257 "DragDropAction.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 257 "DragDropAction.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 260 "DragDropAction.vala"
	_tmp0_ = self->priv->_dragging;
#line 260 "DragDropAction.vala"
	if (!_tmp0_) {
#line 261 "DragDropAction.vala"
		switch (clutter_event_type (event)) {
#line 261 "DragDropAction.vala"
			case CLUTTER_MOTION:
#line 693 "DragDropAction.c"
			{
				GalaDragDropActionDirection _tmp1_;
				gfloat x = 0.0F;
				gfloat y = 0.0F;
				gfloat _tmp2_ = 0.0F;
				gfloat _tmp3_ = 0.0F;
#line 263 "DragDropAction.vala"
				_tmp1_ = self->allow_direction;
#line 263 "DragDropAction.vala"
				if (_tmp1_ == GALA_DRAG_DROP_ACTION_DIRECTION_NONE) {
#line 264 "DragDropAction.vala"
					result = FALSE;
#line 264 "DragDropAction.vala"
					return result;
#line 708 "DragDropAction.c"
				}
#line 268 "DragDropAction.vala"
				clutter_event_get_coords (event, &_tmp2_, &_tmp3_);
#line 268 "DragDropAction.vala"
				x = _tmp2_;
#line 268 "DragDropAction.vala"
				y = _tmp3_;
#line 270 "DragDropAction.vala"
				if (gala_drag_drop_action_drag_allowed (self, event)) {
#line 718 "DragDropAction.c"
					ClutterActor* _tmp4_ = NULL;
					ClutterActor* _tmp5_;
					ClutterActor* _tmp6_;
					ClutterActor* _tmp11_;
					ClutterActor* _tmp12_;
					gfloat _tmp13_;
					gfloat _tmp14_;
					ClutterActor* _tmp15_;
					gfloat _tmp16_;
					gfloat _tmp17_;
					ClutterPoint* _tmp18_;
					ClutterPoint* _tmp19_;
					ClutterPoint* _tmp20_;
					ClutterPoint* _tmp21_;
					ClutterActor* _tmp22_;
					GeeLinkedList* source_list = NULL;
					GeeHashMap* _tmp23_;
					const gchar* _tmp24_;
					gpointer _tmp25_;
					GeeLinkedList* _tmp26_;
#line 271 "DragDropAction.vala"
					g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_BEGIN_SIGNAL], 0, x, y, &_tmp4_);
#line 271 "DragDropAction.vala"
					_tmp5_ = _tmp4_;
#line 271 "DragDropAction.vala"
					gala_drag_drop_action_set_handle (self, _tmp5_);
#line 271 "DragDropAction.vala"
					_g_object_unref0 (_tmp5_);
#line 272 "DragDropAction.vala"
					_tmp6_ = self->priv->_handle;
#line 272 "DragDropAction.vala"
					if (_tmp6_ == NULL) {
#line 751 "DragDropAction.c"
						ClutterActor* _tmp7_;
						ClutterActor* _tmp8_;
						ClutterStage* _tmp9_;
						guint _tmp10_;
#line 274 "DragDropAction.vala"
						_tmp7_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 274 "DragDropAction.vala"
						_tmp8_ = _tmp7_;
#line 274 "DragDropAction.vala"
						_tmp9_ = clutter_actor_get_stage (_tmp8_);
#line 274 "DragDropAction.vala"
						g_signal_parse_name ("captured-event", clutter_actor_get_type (), &_tmp10_, NULL, FALSE);
#line 274 "DragDropAction.vala"
						g_signal_handlers_disconnect_matched ((ClutterActor*) _tmp9_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _gala_drag_drop_action_follow_move_clutter_actor_captured_event, self);
#line 275 "DragDropAction.vala"
						result = FALSE;
#line 275 "DragDropAction.vala"
						return result;
#line 770 "DragDropAction.c"
					}
#line 280 "DragDropAction.vala"
					_tmp11_ = self->priv->_handle;
#line 280 "DragDropAction.vala"
					clutter_actor_queue_relayout (_tmp11_);
#line 281 "DragDropAction.vala"
					_tmp12_ = self->priv->_handle;
#line 281 "DragDropAction.vala"
					_tmp13_ = clutter_actor_get_x (_tmp12_);
#line 281 "DragDropAction.vala"
					_tmp14_ = _tmp13_;
#line 281 "DragDropAction.vala"
					self->priv->orig_x = _tmp14_;
#line 282 "DragDropAction.vala"
					_tmp15_ = self->priv->_handle;
#line 282 "DragDropAction.vala"
					_tmp16_ = clutter_actor_get_y (_tmp15_);
#line 282 "DragDropAction.vala"
					_tmp17_ = _tmp16_;
#line 282 "DragDropAction.vala"
					self->priv->orig_y = _tmp17_;
#line 283 "DragDropAction.vala"
					_tmp18_ = clutter_point_zero ();
#line 283 "DragDropAction.vala"
					_tmp19_ = __vala_ClutterPoint_copy0 (_tmp18_);
#line 283 "DragDropAction.vala"
					__vala_ClutterPoint_free0 (self->priv->offset);
#line 283 "DragDropAction.vala"
					self->priv->offset = _tmp19_;
#line 284 "DragDropAction.vala"
					_tmp20_ = self->priv->offset;
#line 284 "DragDropAction.vala"
					_tmp20_->x = x - self->priv->orig_x;
#line 285 "DragDropAction.vala"
					_tmp21_ = self->priv->offset;
#line 285 "DragDropAction.vala"
					_tmp21_->y = y - self->priv->orig_y;
#line 287 "DragDropAction.vala"
					_tmp22_ = self->priv->_handle;
#line 287 "DragDropAction.vala"
					clutter_actor_set_reactive (_tmp22_, FALSE);
#line 289 "DragDropAction.vala"
					self->priv->clicked = FALSE;
#line 290 "DragDropAction.vala"
					gala_drag_drop_action_set_dragging (self, TRUE);
#line 292 "DragDropAction.vala"
					_tmp23_ = gala_drag_drop_action_sources;
#line 292 "DragDropAction.vala"
					_tmp24_ = self->priv->_drag_id;
#line 292 "DragDropAction.vala"
					_tmp25_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp23_, _tmp24_);
#line 292 "DragDropAction.vala"
					source_list = (GeeLinkedList*) _tmp25_;
#line 293 "DragDropAction.vala"
					_tmp26_ = source_list;
#line 293 "DragDropAction.vala"
					if (_tmp26_ != NULL) {
#line 828 "DragDropAction.c"
						{
							GeeLinkedList* _actor_list = NULL;
							GeeLinkedList* _tmp27_;
							GeeLinkedList* _tmp28_;
							gint _actor_size = 0;
							GeeLinkedList* _tmp29_;
							gint _tmp30_;
							gint _tmp31_;
							gint _actor_index = 0;
#line 294 "DragDropAction.vala"
							_tmp27_ = source_list;
#line 294 "DragDropAction.vala"
							_tmp28_ = _g_object_ref0 (_tmp27_);
#line 294 "DragDropAction.vala"
							_actor_list = _tmp28_;
#line 294 "DragDropAction.vala"
							_tmp29_ = _actor_list;
#line 294 "DragDropAction.vala"
							_tmp30_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp29_);
#line 294 "DragDropAction.vala"
							_tmp31_ = _tmp30_;
#line 294 "DragDropAction.vala"
							_actor_size = _tmp31_;
#line 294 "DragDropAction.vala"
							_actor_index = -1;
#line 294 "DragDropAction.vala"
							while (TRUE) {
#line 856 "DragDropAction.c"
								ClutterActor* actor = NULL;
								GeeLinkedList* _tmp32_;
								gpointer _tmp33_;
								ClutterActor* _tmp34_;
#line 294 "DragDropAction.vala"
								_actor_index = _actor_index + 1;
#line 294 "DragDropAction.vala"
								if (!(_actor_index < _actor_size)) {
#line 294 "DragDropAction.vala"
									break;
#line 867 "DragDropAction.c"
								}
#line 294 "DragDropAction.vala"
								_tmp32_ = _actor_list;
#line 294 "DragDropAction.vala"
								_tmp33_ = gee_abstract_list_get ((GeeAbstractList*) _tmp32_, _actor_index);
#line 294 "DragDropAction.vala"
								actor = (ClutterActor*) _tmp33_;
#line 295 "DragDropAction.vala"
								_tmp34_ = actor;
#line 295 "DragDropAction.vala"
								clutter_actor_set_reactive (_tmp34_, FALSE);
#line 294 "DragDropAction.vala"
								_g_object_unref0 (actor);
#line 881 "DragDropAction.c"
							}
#line 294 "DragDropAction.vala"
							_g_object_unref0 (_actor_list);
#line 885 "DragDropAction.c"
						}
					}
#line 270 "DragDropAction.vala"
					_g_object_unref0 (source_list);
#line 890 "DragDropAction.c"
				}
#line 299 "DragDropAction.vala"
				result = TRUE;
#line 299 "DragDropAction.vala"
				return result;
#line 896 "DragDropAction.c"
			}
#line 261 "DragDropAction.vala"
			case CLUTTER_BUTTON_RELEASE:
#line 900 "DragDropAction.c"
			{
				gfloat x = 0.0F;
				gfloat y = 0.0F;
				gfloat ex = 0.0F;
				gfloat ey = 0.0F;
				gfloat _tmp35_ = 0.0F;
				gfloat _tmp36_ = 0.0F;
				ClutterActor* _tmp37_;
				ClutterActor* _tmp38_;
				gfloat _tmp39_ = 0.0F;
				gfloat _tmp40_ = 0.0F;
				gboolean _tmp41_ = FALSE;
				gboolean _tmp42_ = FALSE;
				gboolean _tmp43_ = FALSE;
				ClutterActor* _tmp52_;
				ClutterActor* _tmp53_;
				ClutterStage* _tmp54_;
				guint _tmp55_;
#line 302 "DragDropAction.vala"
				clutter_event_get_coords (event, &_tmp35_, &_tmp36_);
#line 302 "DragDropAction.vala"
				ex = _tmp35_;
#line 302 "DragDropAction.vala"
				ey = _tmp36_;
#line 303 "DragDropAction.vala"
				_tmp37_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 303 "DragDropAction.vala"
				_tmp38_ = _tmp37_;
#line 303 "DragDropAction.vala"
				clutter_actor_get_transformed_position (_tmp38_, &_tmp39_, &_tmp40_);
#line 303 "DragDropAction.vala"
				x = _tmp39_;
#line 303 "DragDropAction.vala"
				y = _tmp40_;
#line 306 "DragDropAction.vala"
				if (x < ex) {
#line 937 "DragDropAction.c"
					ClutterActor* _tmp44_;
					ClutterActor* _tmp45_;
					gfloat _tmp46_;
					gfloat _tmp47_;
#line 306 "DragDropAction.vala"
					_tmp44_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 306 "DragDropAction.vala"
					_tmp45_ = _tmp44_;
#line 306 "DragDropAction.vala"
					_tmp46_ = clutter_actor_get_width (_tmp45_);
#line 306 "DragDropAction.vala"
					_tmp47_ = _tmp46_;
#line 306 "DragDropAction.vala"
					_tmp43_ = (x + _tmp47_) > ex;
#line 952 "DragDropAction.c"
				} else {
#line 306 "DragDropAction.vala"
					_tmp43_ = FALSE;
#line 956 "DragDropAction.c"
				}
#line 306 "DragDropAction.vala"
				if (_tmp43_) {
#line 306 "DragDropAction.vala"
					_tmp42_ = y < ey;
#line 962 "DragDropAction.c"
				} else {
#line 306 "DragDropAction.vala"
					_tmp42_ = FALSE;
#line 966 "DragDropAction.c"
				}
#line 306 "DragDropAction.vala"
				if (_tmp42_) {
#line 970 "DragDropAction.c"
					ClutterActor* _tmp48_;
					ClutterActor* _tmp49_;
					gfloat _tmp50_;
					gfloat _tmp51_;
#line 306 "DragDropAction.vala"
					_tmp48_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 306 "DragDropAction.vala"
					_tmp49_ = _tmp48_;
#line 306 "DragDropAction.vala"
					_tmp50_ = clutter_actor_get_height (_tmp49_);
#line 306 "DragDropAction.vala"
					_tmp51_ = _tmp50_;
#line 306 "DragDropAction.vala"
					_tmp41_ = (y + _tmp51_) > ey;
#line 985 "DragDropAction.c"
				} else {
#line 306 "DragDropAction.vala"
					_tmp41_ = FALSE;
#line 989 "DragDropAction.c"
				}
#line 306 "DragDropAction.vala"
				if (_tmp41_) {
#line 307 "DragDropAction.vala"
					g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL], 0, clutter_event_get_button (event));
#line 995 "DragDropAction.c"
				}
#line 310 "DragDropAction.vala"
				_tmp52_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 310 "DragDropAction.vala"
				_tmp53_ = _tmp52_;
#line 310 "DragDropAction.vala"
				_tmp54_ = clutter_actor_get_stage (_tmp53_);
#line 310 "DragDropAction.vala"
				g_signal_parse_name ("captured-event", clutter_actor_get_type (), &_tmp55_, NULL, FALSE);
#line 310 "DragDropAction.vala"
				g_signal_handlers_disconnect_matched ((ClutterActor*) _tmp54_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp55_, 0, NULL, (GCallback) _gala_drag_drop_action_follow_move_clutter_actor_captured_event, self);
#line 311 "DragDropAction.vala"
				self->priv->clicked = FALSE;
#line 312 "DragDropAction.vala"
				gala_drag_drop_action_set_dragging (self, FALSE);
#line 314 "DragDropAction.vala"
				result = FALSE;
#line 314 "DragDropAction.vala"
				return result;
#line 1015 "DragDropAction.c"
			}
			default:
			{
#line 316 "DragDropAction.vala"
				result = TRUE;
#line 316 "DragDropAction.vala"
				return result;
#line 1023 "DragDropAction.c"
			}
		}
	}
#line 320 "DragDropAction.vala"
	switch (clutter_event_type (event)) {
#line 320 "DragDropAction.vala"
		case CLUTTER_KEY_PRESS:
#line 1031 "DragDropAction.c"
		{
#line 322 "DragDropAction.vala"
			if (((guint) clutter_event_get_key_code (event)) == CLUTTER_KEY_Escape) {
#line 323 "DragDropAction.vala"
				gala_drag_drop_action_cancel (self);
#line 1037 "DragDropAction.c"
			}
#line 325 "DragDropAction.vala"
			result = TRUE;
#line 325 "DragDropAction.vala"
			return result;
#line 1043 "DragDropAction.c"
		}
#line 320 "DragDropAction.vala"
		case CLUTTER_MOTION:
#line 1047 "DragDropAction.c"
		{
			gfloat x = 0.0F;
			gfloat y = 0.0F;
			gfloat _tmp56_ = 0.0F;
			gfloat _tmp57_ = 0.0F;
			GalaDragDropActionDirection _tmp58_;
			GalaDragDropActionDirection _tmp62_;
			GalaDragDropActionDirection _tmp66_;
			GalaDragDropActionDirection _tmp70_;
			gboolean _tmp77_ = FALSE;
			ClutterActor* _tmp78_;
			gfloat _tmp79_;
			gfloat _tmp80_;
			ClutterStage* stage = NULL;
			ClutterActor* _tmp90_;
			ClutterActor* _tmp91_;
			ClutterStage* _tmp92_;
			ClutterStage* _tmp93_;
			ClutterActor* actor = NULL;
			ClutterStage* _tmp94_;
			ClutterActor* _tmp95_;
			ClutterActor* _tmp96_;
			GalaDragDropAction* action = NULL;
			gboolean _tmp97_ = FALSE;
			gboolean _tmp98_ = FALSE;
			gboolean _tmp99_ = FALSE;
			ClutterActor* _tmp100_;
			ClutterActor* _tmp115_;
			ClutterActor* _tmp116_;
			GalaDragDropAction* _tmp117_;
			ClutterActor* _tmp120_;
			ClutterActor* _tmp122_;
			ClutterActor* _tmp123_;
			ClutterActor* _tmp124_;
#line 329 "DragDropAction.vala"
			clutter_event_get_coords (event, &_tmp56_, &_tmp57_);
#line 329 "DragDropAction.vala"
			x = _tmp56_;
#line 329 "DragDropAction.vala"
			y = _tmp57_;
#line 332 "DragDropAction.vala"
			_tmp58_ = self->allow_direction;
#line 332 "DragDropAction.vala"
			if ((_tmp58_ & GALA_DRAG_DROP_ACTION_DIRECTION_LEFT) == GALA_DRAG_DROP_ACTION_DIRECTION_LEFT) {
#line 1092 "DragDropAction.c"
				ClutterPoint* _tmp59_;
#line 334 "DragDropAction.vala"
				_tmp59_ = self->priv->offset;
#line 334 "DragDropAction.vala"
				if ((x - _tmp59_->x) <= self->priv->orig_x) {
#line 1098 "DragDropAction.c"
					ClutterActor* _tmp60_;
					ClutterPoint* _tmp61_;
#line 335 "DragDropAction.vala"
					_tmp60_ = self->priv->_handle;
#line 335 "DragDropAction.vala"
					_tmp61_ = self->priv->offset;
#line 335 "DragDropAction.vala"
					clutter_actor_set_x (_tmp60_, x - _tmp61_->x);
#line 1107 "DragDropAction.c"
				}
			}
#line 338 "DragDropAction.vala"
			_tmp62_ = self->allow_direction;
#line 338 "DragDropAction.vala"
			if ((_tmp62_ & GALA_DRAG_DROP_ACTION_DIRECTION_RIGHT) == GALA_DRAG_DROP_ACTION_DIRECTION_RIGHT) {
#line 1114 "DragDropAction.c"
				ClutterPoint* _tmp63_;
#line 340 "DragDropAction.vala"
				_tmp63_ = self->priv->offset;
#line 340 "DragDropAction.vala"
				if ((x - _tmp63_->x) >= self->priv->orig_x) {
#line 1120 "DragDropAction.c"
					ClutterActor* _tmp64_;
					ClutterPoint* _tmp65_;
#line 341 "DragDropAction.vala"
					_tmp64_ = self->priv->_handle;
#line 341 "DragDropAction.vala"
					_tmp65_ = self->priv->offset;
#line 341 "DragDropAction.vala"
					clutter_actor_set_x (_tmp64_, x - _tmp65_->x);
#line 1129 "DragDropAction.c"
				}
			}
#line 344 "DragDropAction.vala"
			_tmp66_ = self->allow_direction;
#line 344 "DragDropAction.vala"
			if ((_tmp66_ & GALA_DRAG_DROP_ACTION_DIRECTION_UP) == GALA_DRAG_DROP_ACTION_DIRECTION_UP) {
#line 1136 "DragDropAction.c"
				ClutterPoint* _tmp67_;
#line 346 "DragDropAction.vala"
				_tmp67_ = self->priv->offset;
#line 346 "DragDropAction.vala"
				if ((y - _tmp67_->y) <= self->priv->orig_y) {
#line 1142 "DragDropAction.c"
					ClutterActor* _tmp68_;
					ClutterPoint* _tmp69_;
#line 347 "DragDropAction.vala"
					_tmp68_ = self->priv->_handle;
#line 347 "DragDropAction.vala"
					_tmp69_ = self->priv->offset;
#line 347 "DragDropAction.vala"
					clutter_actor_set_y (_tmp68_, y - _tmp69_->y);
#line 1151 "DragDropAction.c"
				}
			}
#line 350 "DragDropAction.vala"
			_tmp70_ = self->allow_direction;
#line 350 "DragDropAction.vala"
			if ((_tmp70_ & GALA_DRAG_DROP_ACTION_DIRECTION_DOWN) == GALA_DRAG_DROP_ACTION_DIRECTION_DOWN) {
#line 1158 "DragDropAction.c"
				ClutterPoint* _tmp71_;
#line 352 "DragDropAction.vala"
				_tmp71_ = self->priv->offset;
#line 352 "DragDropAction.vala"
				if ((y - _tmp71_->y) >= self->priv->orig_y) {
#line 1164 "DragDropAction.c"
					ClutterActor* _tmp72_;
					ClutterPoint* _tmp73_;
#line 353 "DragDropAction.vala"
					_tmp72_ = self->priv->_handle;
#line 353 "DragDropAction.vala"
					_tmp73_ = self->priv->offset;
#line 353 "DragDropAction.vala"
					clutter_actor_set_y (_tmp72_, y - _tmp73_->y);
#line 1173 "DragDropAction.c"
				}
			}
#line 357 "DragDropAction.vala"
			if (self->allow_y_overflow > 0.0f) {
#line 1178 "DragDropAction.c"
				gfloat d = 0.0F;
				ClutterPoint* _tmp74_;
#line 358 "DragDropAction.vala"
				_tmp74_ = self->priv->offset;
#line 358 "DragDropAction.vala"
				d = (y - _tmp74_->y) - self->priv->orig_y;
#line 359 "DragDropAction.vala"
				if (d < self->allow_y_overflow) {
#line 1187 "DragDropAction.c"
					ClutterActor* _tmp75_;
					ClutterPoint* _tmp76_;
#line 360 "DragDropAction.vala"
					_tmp75_ = self->priv->_handle;
#line 360 "DragDropAction.vala"
					_tmp76_ = self->priv->offset;
#line 360 "DragDropAction.vala"
					clutter_actor_set_y (_tmp75_, y - _tmp76_->y);
#line 1196 "DragDropAction.c"
				}
			}
#line 363 "DragDropAction.vala"
			_tmp78_ = self->priv->_handle;
#line 363 "DragDropAction.vala"
			_tmp79_ = clutter_actor_get_x (_tmp78_);
#line 363 "DragDropAction.vala"
			_tmp80_ = _tmp79_;
#line 363 "DragDropAction.vala"
			if (_tmp80_ != self->priv->orig_x) {
#line 363 "DragDropAction.vala"
				_tmp77_ = TRUE;
#line 1209 "DragDropAction.c"
			} else {
				ClutterActor* _tmp81_;
				gfloat _tmp82_;
				gfloat _tmp83_;
#line 363 "DragDropAction.vala"
				_tmp81_ = self->priv->_handle;
#line 363 "DragDropAction.vala"
				_tmp82_ = clutter_actor_get_y (_tmp81_);
#line 363 "DragDropAction.vala"
				_tmp83_ = _tmp82_;
#line 363 "DragDropAction.vala"
				_tmp77_ = _tmp83_ != self->priv->orig_y;
#line 1222 "DragDropAction.c"
			}
#line 363 "DragDropAction.vala"
			if (_tmp77_) {
#line 1226 "DragDropAction.c"
				ClutterActor* _tmp84_;
				gfloat _tmp85_;
				gfloat _tmp86_;
				ClutterActor* _tmp87_;
				gfloat _tmp88_;
				gfloat _tmp89_;
#line 364 "DragDropAction.vala"
				_tmp84_ = self->priv->_handle;
#line 364 "DragDropAction.vala"
				_tmp85_ = clutter_actor_get_x (_tmp84_);
#line 364 "DragDropAction.vala"
				_tmp86_ = _tmp85_;
#line 364 "DragDropAction.vala"
				_tmp87_ = self->priv->_handle;
#line 364 "DragDropAction.vala"
				_tmp88_ = clutter_actor_get_y (_tmp87_);
#line 364 "DragDropAction.vala"
				_tmp89_ = _tmp88_;
#line 364 "DragDropAction.vala"
				g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_MOTION_SIGNAL], 0, _tmp86_ - self->priv->orig_x, _tmp89_ - self->priv->orig_y);
#line 1247 "DragDropAction.c"
			}
#line 366 "DragDropAction.vala"
			_tmp90_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 366 "DragDropAction.vala"
			_tmp91_ = _tmp90_;
#line 366 "DragDropAction.vala"
			_tmp92_ = clutter_actor_get_stage (_tmp91_);
#line 366 "DragDropAction.vala"
			_tmp93_ = _g_object_ref0 (_tmp92_);
#line 366 "DragDropAction.vala"
			stage = _tmp93_;
#line 367 "DragDropAction.vala"
			_tmp94_ = stage;
#line 367 "DragDropAction.vala"
			_tmp95_ = clutter_stage_get_actor_at_pos (_tmp94_, CLUTTER_PICK_REACTIVE, (gint) x, (gint) y);
#line 367 "DragDropAction.vala"
			_tmp96_ = _g_object_ref0 (_tmp95_);
#line 367 "DragDropAction.vala"
			actor = _tmp96_;
#line 368 "DragDropAction.vala"
			action = NULL;
#line 370 "DragDropAction.vala"
			_tmp100_ = actor;
#line 370 "DragDropAction.vala"
			if (_tmp100_ != NULL) {
#line 1273 "DragDropAction.c"
				ClutterActor* _tmp101_;
				ClutterStage* _tmp102_;
#line 370 "DragDropAction.vala"
				_tmp101_ = actor;
#line 370 "DragDropAction.vala"
				_tmp102_ = stage;
#line 370 "DragDropAction.vala"
				_tmp99_ = _tmp101_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp102_, clutter_actor_get_type (), ClutterActor);
#line 1282 "DragDropAction.c"
			} else {
#line 370 "DragDropAction.vala"
				_tmp99_ = FALSE;
#line 1286 "DragDropAction.c"
			}
#line 370 "DragDropAction.vala"
			if (_tmp99_) {
#line 1290 "DragDropAction.c"
				ClutterActor* _tmp103_;
				GalaDragDropAction* _tmp104_;
				GalaDragDropAction* _tmp105_;
#line 371 "DragDropAction.vala"
				_tmp103_ = actor;
#line 371 "DragDropAction.vala"
				_tmp104_ = gala_drag_drop_action_get_drag_drop_action (self, _tmp103_);
#line 371 "DragDropAction.vala"
				_g_object_unref0 (action);
#line 371 "DragDropAction.vala"
				action = _tmp104_;
#line 371 "DragDropAction.vala"
				_tmp105_ = action;
#line 371 "DragDropAction.vala"
				_tmp98_ = _tmp105_ == NULL;
#line 1306 "DragDropAction.c"
			} else {
#line 370 "DragDropAction.vala"
				_tmp98_ = FALSE;
#line 1310 "DragDropAction.c"
			}
#line 370 "DragDropAction.vala"
			if (_tmp98_) {
#line 1314 "DragDropAction.c"
				gboolean _tmp106_;
#line 371 "DragDropAction.vala"
				_tmp106_ = self->priv->_allow_bubbling;
#line 371 "DragDropAction.vala"
				_tmp97_ = _tmp106_;
#line 1320 "DragDropAction.c"
			} else {
#line 370 "DragDropAction.vala"
				_tmp97_ = FALSE;
#line 1324 "DragDropAction.c"
			}
#line 370 "DragDropAction.vala"
			if (_tmp97_) {
#line 372 "DragDropAction.vala"
				while (TRUE) {
#line 1330 "DragDropAction.c"
					ClutterActor* _tmp107_;
					ClutterActor* _tmp108_;
					ClutterActor* _tmp109_;
					ClutterActor* _tmp110_;
					ClutterStage* _tmp111_;
					ClutterActor* _tmp112_;
					GalaDragDropAction* _tmp113_;
					GalaDragDropAction* _tmp114_;
#line 372 "DragDropAction.vala"
					_tmp107_ = actor;
#line 372 "DragDropAction.vala"
					_tmp108_ = clutter_actor_get_parent (_tmp107_);
#line 372 "DragDropAction.vala"
					_tmp109_ = _g_object_ref0 (_tmp108_);
#line 372 "DragDropAction.vala"
					_g_object_unref0 (actor);
#line 372 "DragDropAction.vala"
					actor = _tmp109_;
#line 372 "DragDropAction.vala"
					_tmp110_ = actor;
#line 372 "DragDropAction.vala"
					_tmp111_ = stage;
#line 372 "DragDropAction.vala"
					if (!(_tmp110_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp111_, clutter_actor_get_type (), ClutterActor))) {
#line 372 "DragDropAction.vala"
						break;
#line 1357 "DragDropAction.c"
					}
#line 373 "DragDropAction.vala"
					_tmp112_ = actor;
#line 373 "DragDropAction.vala"
					_tmp113_ = gala_drag_drop_action_get_drag_drop_action (self, _tmp112_);
#line 373 "DragDropAction.vala"
					_g_object_unref0 (action);
#line 373 "DragDropAction.vala"
					action = _tmp113_;
#line 373 "DragDropAction.vala"
					_tmp114_ = action;
#line 373 "DragDropAction.vala"
					if (_tmp114_ != NULL) {
#line 374 "DragDropAction.vala"
						break;
#line 1373 "DragDropAction.c"
					}
				}
			}
#line 379 "DragDropAction.vala"
			_tmp115_ = actor;
#line 379 "DragDropAction.vala"
			_tmp116_ = self->priv->hovered;
#line 379 "DragDropAction.vala"
			if (_tmp115_ == _tmp116_) {
#line 380 "DragDropAction.vala"
				result = TRUE;
#line 380 "DragDropAction.vala"
				_g_object_unref0 (action);
#line 380 "DragDropAction.vala"
				_g_object_unref0 (actor);
#line 380 "DragDropAction.vala"
				_g_object_unref0 (stage);
#line 380 "DragDropAction.vala"
				return result;
#line 1393 "DragDropAction.c"
			}
#line 382 "DragDropAction.vala"
			_tmp117_ = action;
#line 382 "DragDropAction.vala"
			if (_tmp117_ == NULL) {
#line 1399 "DragDropAction.c"
				ClutterActor* _tmp118_;
#line 384 "DragDropAction.vala"
				_tmp118_ = self->priv->hovered;
#line 384 "DragDropAction.vala"
				if (_tmp118_ != NULL) {
#line 1405 "DragDropAction.c"
					ClutterActor* _tmp119_;
#line 385 "DragDropAction.vala"
					_tmp119_ = self->priv->hovered;
#line 385 "DragDropAction.vala"
					gala_drag_drop_action_emit_crossed (self, _tmp119_, FALSE);
#line 386 "DragDropAction.vala"
					_g_object_unref0 (self->priv->hovered);
#line 386 "DragDropAction.vala"
					self->priv->hovered = NULL;
#line 1415 "DragDropAction.c"
				}
#line 389 "DragDropAction.vala"
				result = TRUE;
#line 389 "DragDropAction.vala"
				_g_object_unref0 (action);
#line 389 "DragDropAction.vala"
				_g_object_unref0 (actor);
#line 389 "DragDropAction.vala"
				_g_object_unref0 (stage);
#line 389 "DragDropAction.vala"
				return result;
#line 1427 "DragDropAction.c"
			}
#line 393 "DragDropAction.vala"
			_tmp120_ = self->priv->hovered;
#line 393 "DragDropAction.vala"
			if (_tmp120_ != NULL) {
#line 1433 "DragDropAction.c"
				ClutterActor* _tmp121_;
#line 394 "DragDropAction.vala"
				_tmp121_ = self->priv->hovered;
#line 394 "DragDropAction.vala"
				gala_drag_drop_action_emit_crossed (self, _tmp121_, FALSE);
#line 1439 "DragDropAction.c"
			}
#line 398 "DragDropAction.vala"
			_tmp122_ = actor;
#line 398 "DragDropAction.vala"
			_tmp123_ = _g_object_ref0 (_tmp122_);
#line 398 "DragDropAction.vala"
			_g_object_unref0 (self->priv->hovered);
#line 398 "DragDropAction.vala"
			self->priv->hovered = _tmp123_;
#line 399 "DragDropAction.vala"
			_tmp124_ = self->priv->hovered;
#line 399 "DragDropAction.vala"
			gala_drag_drop_action_emit_crossed (self, _tmp124_, TRUE);
#line 401 "DragDropAction.vala"
			result = TRUE;
#line 401 "DragDropAction.vala"
			_g_object_unref0 (action);
#line 401 "DragDropAction.vala"
			_g_object_unref0 (actor);
#line 401 "DragDropAction.vala"
			_g_object_unref0 (stage);
#line 401 "DragDropAction.vala"
			return result;
#line 1463 "DragDropAction.c"
		}
#line 320 "DragDropAction.vala"
		case CLUTTER_BUTTON_RELEASE:
#line 1467 "DragDropAction.c"
		{
			ClutterActor* _tmp125_;
#line 403 "DragDropAction.vala"
			_tmp125_ = self->priv->hovered;
#line 403 "DragDropAction.vala"
			if (_tmp125_ != NULL) {
#line 404 "DragDropAction.vala"
				gala_drag_drop_action_finish (self);
#line 1476 "DragDropAction.c"
			} else {
#line 406 "DragDropAction.vala"
				gala_drag_drop_action_cancel (self);
#line 1480 "DragDropAction.c"
			}
#line 408 "DragDropAction.vala"
			result = TRUE;
#line 408 "DragDropAction.vala"
			return result;
#line 1486 "DragDropAction.c"
		}
#line 320 "DragDropAction.vala"
		case CLUTTER_ENTER:
#line 320 "DragDropAction.vala"
		case CLUTTER_LEAVE:
#line 1492 "DragDropAction.c"
		{
#line 411 "DragDropAction.vala"
			result = TRUE;
#line 411 "DragDropAction.vala"
			return result;
#line 1498 "DragDropAction.c"
		}
		default:
#line 320 "DragDropAction.vala"
		break;
#line 1503 "DragDropAction.c"
	}
#line 414 "DragDropAction.vala"
	result = FALSE;
#line 414 "DragDropAction.vala"
	return result;
#line 1509 "DragDropAction.c"
}

/**
 * Looks for a DragDropAction instance if this actor has one or NULL.
 * It also checks if it is a DESTINATION and if the id matches
 *
 * @return the DragDropAction instance on this actor or NULL
 */
static GalaDragDropAction*
gala_drag_drop_action_get_drag_drop_action (GalaDragDropAction* self,
                                            ClutterActor* actor)
{
	GalaDragDropAction* result = NULL;
	GalaDragDropAction* drop_action = NULL;
	GList* _tmp0_;
#line 423 "DragDropAction.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 423 "DragDropAction.vala"
	g_return_val_if_fail (actor != NULL, NULL);
#line 425 "DragDropAction.vala"
	drop_action = NULL;
#line 427 "DragDropAction.vala"
	_tmp0_ = clutter_actor_get_actions (actor);
#line 1533 "DragDropAction.c"
	{
		GList* action_collection = NULL;
		GList* action_it = NULL;
#line 427 "DragDropAction.vala"
		action_collection = _tmp0_;
#line 427 "DragDropAction.vala"
		for (action_it = action_collection; action_it != NULL; action_it = action_it->next) {
#line 1541 "DragDropAction.c"
			ClutterAction* action = NULL;
#line 427 "DragDropAction.vala"
			action = (ClutterAction*) action_it->data;
#line 1545 "DragDropAction.c"
			{
				ClutterAction* _tmp1_;
				GalaDragDropAction* _tmp2_;
				gboolean _tmp3_ = FALSE;
				gboolean _tmp4_ = FALSE;
				GalaDragDropAction* _tmp5_;
#line 428 "DragDropAction.vala"
				_tmp1_ = action;
#line 428 "DragDropAction.vala"
				_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, GALA_TYPE_DRAG_DROP_ACTION) ? ((GalaDragDropAction*) _tmp1_) : NULL);
#line 428 "DragDropAction.vala"
				_g_object_unref0 (drop_action);
#line 428 "DragDropAction.vala"
				drop_action = _tmp2_;
#line 429 "DragDropAction.vala"
				_tmp5_ = drop_action;
#line 429 "DragDropAction.vala"
				if (_tmp5_ == NULL) {
#line 429 "DragDropAction.vala"
					_tmp4_ = TRUE;
#line 1566 "DragDropAction.c"
				} else {
					GalaDragDropAction* _tmp6_;
					GalaDragDropActionType _tmp7_;
#line 430 "DragDropAction.vala"
					_tmp6_ = drop_action;
#line 430 "DragDropAction.vala"
					_tmp7_ = _tmp6_->priv->_drag_type;
#line 430 "DragDropAction.vala"
					_tmp4_ = _tmp7_ != GALA_DRAG_DROP_ACTION_TYPE_DESTINATION;
#line 1576 "DragDropAction.c"
				}
#line 429 "DragDropAction.vala"
				if (_tmp4_) {
#line 429 "DragDropAction.vala"
					_tmp3_ = TRUE;
#line 1582 "DragDropAction.c"
				} else {
					GalaDragDropAction* _tmp8_;
					const gchar* _tmp9_;
					const gchar* _tmp10_;
#line 431 "DragDropAction.vala"
					_tmp8_ = drop_action;
#line 431 "DragDropAction.vala"
					_tmp9_ = _tmp8_->priv->_drag_id;
#line 431 "DragDropAction.vala"
					_tmp10_ = self->priv->_drag_id;
#line 431 "DragDropAction.vala"
					_tmp3_ = g_strcmp0 (_tmp9_, _tmp10_) != 0;
#line 1595 "DragDropAction.c"
				}
#line 429 "DragDropAction.vala"
				if (_tmp3_) {
#line 432 "DragDropAction.vala"
					continue;
#line 1601 "DragDropAction.c"
				}
#line 434 "DragDropAction.vala"
				result = drop_action;
#line 434 "DragDropAction.vala"
				(action_collection == NULL) ? NULL : (action_collection = (g_list_free (action_collection), NULL));
#line 434 "DragDropAction.vala"
				return result;
#line 1609 "DragDropAction.c"
			}
		}
#line 427 "DragDropAction.vala"
		(action_collection == NULL) ? NULL : (action_collection = (g_list_free (action_collection), NULL));
#line 1614 "DragDropAction.c"
	}
#line 437 "DragDropAction.vala"
	result = NULL;
#line 437 "DragDropAction.vala"
	_g_object_unref0 (drop_action);
#line 437 "DragDropAction.vala"
	return result;
#line 1622 "DragDropAction.c"
}

/**
 * Abort the drag
 */
void
gala_drag_drop_action_cancel (GalaDragDropAction* self)
{
#line 443 "DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 445 "DragDropAction.vala"
	gala_drag_drop_action_cleanup (self);
#line 447 "DragDropAction.vala"
	g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_CANCELED_SIGNAL], 0);
#line 1637 "DragDropAction.c"
}

/**
 * Allows you to abort all drags currently running for a given drag-id
 */
void
gala_drag_drop_action_cancel_all_by_id (const gchar* id)
{
	GeeLinkedList* actors = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GeeLinkedList* _tmp2_;
#line 453 "DragDropAction.vala"
	g_return_if_fail (id != NULL);
#line 455 "DragDropAction.vala"
	_tmp0_ = gala_drag_drop_action_sources;
#line 455 "DragDropAction.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, id);
#line 455 "DragDropAction.vala"
	actors = (GeeLinkedList*) _tmp1_;
#line 456 "DragDropAction.vala"
	_tmp2_ = actors;
#line 456 "DragDropAction.vala"
	if (_tmp2_ == NULL) {
#line 457 "DragDropAction.vala"
		_g_object_unref0 (actors);
#line 457 "DragDropAction.vala"
		return;
#line 1666 "DragDropAction.c"
	}
	{
		GeeLinkedList* _actor_list = NULL;
		GeeLinkedList* _tmp3_;
		GeeLinkedList* _tmp4_;
		gint _actor_size = 0;
		GeeLinkedList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _actor_index = 0;
#line 459 "DragDropAction.vala"
		_tmp3_ = actors;
#line 459 "DragDropAction.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 459 "DragDropAction.vala"
		_actor_list = _tmp4_;
#line 459 "DragDropAction.vala"
		_tmp5_ = _actor_list;
#line 459 "DragDropAction.vala"
		_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 459 "DragDropAction.vala"
		_tmp7_ = _tmp6_;
#line 459 "DragDropAction.vala"
		_actor_size = _tmp7_;
#line 459 "DragDropAction.vala"
		_actor_index = -1;
#line 459 "DragDropAction.vala"
		while (TRUE) {
#line 1695 "DragDropAction.c"
			ClutterActor* actor = NULL;
			GeeLinkedList* _tmp8_;
			gpointer _tmp9_;
			ClutterActor* _tmp10_;
			GList* _tmp11_;
#line 459 "DragDropAction.vala"
			_actor_index = _actor_index + 1;
#line 459 "DragDropAction.vala"
			if (!(_actor_index < _actor_size)) {
#line 459 "DragDropAction.vala"
				break;
#line 1707 "DragDropAction.c"
			}
#line 459 "DragDropAction.vala"
			_tmp8_ = _actor_list;
#line 459 "DragDropAction.vala"
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _actor_index);
#line 459 "DragDropAction.vala"
			actor = (ClutterActor*) _tmp9_;
#line 460 "DragDropAction.vala"
			_tmp10_ = actor;
#line 460 "DragDropAction.vala"
			_tmp11_ = clutter_actor_get_actions (_tmp10_);
#line 1719 "DragDropAction.c"
			{
				GList* action_collection = NULL;
				GList* action_it = NULL;
#line 460 "DragDropAction.vala"
				action_collection = _tmp11_;
#line 460 "DragDropAction.vala"
				for (action_it = action_collection; action_it != NULL; action_it = action_it->next) {
#line 1727 "DragDropAction.c"
					ClutterAction* action = NULL;
#line 460 "DragDropAction.vala"
					action = (ClutterAction*) action_it->data;
#line 1731 "DragDropAction.c"
					{
						GalaDragDropAction* drag_action = NULL;
						ClutterAction* _tmp12_;
						GalaDragDropAction* _tmp13_;
						gboolean _tmp14_ = FALSE;
						GalaDragDropAction* _tmp15_;
#line 461 "DragDropAction.vala"
						_tmp12_ = action;
#line 461 "DragDropAction.vala"
						_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, GALA_TYPE_DRAG_DROP_ACTION) ? ((GalaDragDropAction*) _tmp12_) : NULL);
#line 461 "DragDropAction.vala"
						drag_action = _tmp13_;
#line 462 "DragDropAction.vala"
						_tmp15_ = drag_action;
#line 462 "DragDropAction.vala"
						if (_tmp15_ != NULL) {
#line 1748 "DragDropAction.c"
							GalaDragDropAction* _tmp16_;
							gboolean _tmp17_;
#line 462 "DragDropAction.vala"
							_tmp16_ = drag_action;
#line 462 "DragDropAction.vala"
							_tmp17_ = _tmp16_->priv->_dragging;
#line 462 "DragDropAction.vala"
							_tmp14_ = _tmp17_;
#line 1757 "DragDropAction.c"
						} else {
#line 462 "DragDropAction.vala"
							_tmp14_ = FALSE;
#line 1761 "DragDropAction.c"
						}
#line 462 "DragDropAction.vala"
						if (_tmp14_) {
#line 1765 "DragDropAction.c"
							GalaDragDropAction* _tmp18_;
#line 463 "DragDropAction.vala"
							_tmp18_ = drag_action;
#line 463 "DragDropAction.vala"
							gala_drag_drop_action_cancel (_tmp18_);
#line 464 "DragDropAction.vala"
							_g_object_unref0 (drag_action);
#line 464 "DragDropAction.vala"
							break;
#line 1775 "DragDropAction.c"
						}
#line 460 "DragDropAction.vala"
						_g_object_unref0 (drag_action);
#line 1779 "DragDropAction.c"
					}
				}
#line 460 "DragDropAction.vala"
				(action_collection == NULL) ? NULL : (action_collection = (g_list_free (action_collection), NULL));
#line 1784 "DragDropAction.c"
			}
#line 459 "DragDropAction.vala"
			_g_object_unref0 (actor);
#line 1788 "DragDropAction.c"
		}
#line 459 "DragDropAction.vala"
		_g_object_unref0 (_actor_list);
#line 1792 "DragDropAction.c"
	}
#line 453 "DragDropAction.vala"
	_g_object_unref0 (actors);
#line 1796 "DragDropAction.c"
}

static void
gala_drag_drop_action_finish (GalaDragDropAction* self)
{
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
#line 470 "DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 473 "DragDropAction.vala"
	_tmp0_ = self->priv->hovered;
#line 473 "DragDropAction.vala"
	gala_drag_drop_action_emit_crossed (self, _tmp0_, FALSE);
#line 475 "DragDropAction.vala"
	gala_drag_drop_action_cleanup (self);
#line 477 "DragDropAction.vala"
	_tmp1_ = self->priv->hovered;
#line 477 "DragDropAction.vala"
	g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_END_SIGNAL], 0, _tmp1_);
#line 1816 "DragDropAction.c"
}

static void
gala_drag_drop_action_cleanup (GalaDragDropAction* self)
{
	GeeLinkedList* source_list = NULL;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gpointer _tmp2_;
	GeeLinkedList* _tmp3_;
	gboolean _tmp12_;
#line 480 "DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 482 "DragDropAction.vala"
	_tmp0_ = gala_drag_drop_action_sources;
#line 482 "DragDropAction.vala"
	_tmp1_ = self->priv->_drag_id;
#line 482 "DragDropAction.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 482 "DragDropAction.vala"
	source_list = (GeeLinkedList*) _tmp2_;
#line 483 "DragDropAction.vala"
	_tmp3_ = source_list;
#line 483 "DragDropAction.vala"
	if (_tmp3_ != NULL) {
#line 1842 "DragDropAction.c"
		{
			GeeLinkedList* _actor_list = NULL;
			GeeLinkedList* _tmp4_;
			GeeLinkedList* _tmp5_;
			gint _actor_size = 0;
			GeeLinkedList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _actor_index = 0;
#line 484 "DragDropAction.vala"
			_tmp4_ = source_list;
#line 484 "DragDropAction.vala"
			_tmp5_ = _g_object_ref0 (_tmp4_);
#line 484 "DragDropAction.vala"
			_actor_list = _tmp5_;
#line 484 "DragDropAction.vala"
			_tmp6_ = _actor_list;
#line 484 "DragDropAction.vala"
			_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 484 "DragDropAction.vala"
			_tmp8_ = _tmp7_;
#line 484 "DragDropAction.vala"
			_actor_size = _tmp8_;
#line 484 "DragDropAction.vala"
			_actor_index = -1;
#line 484 "DragDropAction.vala"
			while (TRUE) {
#line 1870 "DragDropAction.c"
				ClutterActor* actor = NULL;
				GeeLinkedList* _tmp9_;
				gpointer _tmp10_;
				ClutterActor* _tmp11_;
#line 484 "DragDropAction.vala"
				_actor_index = _actor_index + 1;
#line 484 "DragDropAction.vala"
				if (!(_actor_index < _actor_size)) {
#line 484 "DragDropAction.vala"
					break;
#line 1881 "DragDropAction.c"
				}
#line 484 "DragDropAction.vala"
				_tmp9_ = _actor_list;
#line 484 "DragDropAction.vala"
				_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _actor_index);
#line 484 "DragDropAction.vala"
				actor = (ClutterActor*) _tmp10_;
#line 485 "DragDropAction.vala"
				_tmp11_ = actor;
#line 485 "DragDropAction.vala"
				clutter_actor_set_reactive (_tmp11_, TRUE);
#line 484 "DragDropAction.vala"
				_g_object_unref0 (actor);
#line 1895 "DragDropAction.c"
			}
#line 484 "DragDropAction.vala"
			_g_object_unref0 (_actor_list);
#line 1899 "DragDropAction.c"
		}
	}
#line 489 "DragDropAction.vala"
	_tmp12_ = self->priv->_dragging;
#line 489 "DragDropAction.vala"
	if (_tmp12_) {
#line 1906 "DragDropAction.c"
		ClutterActor* _tmp13_;
		ClutterActor* _tmp14_;
		ClutterStage* _tmp15_;
		guint _tmp16_;
#line 490 "DragDropAction.vala"
		_tmp13_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 490 "DragDropAction.vala"
		_tmp14_ = _tmp13_;
#line 490 "DragDropAction.vala"
		_tmp15_ = clutter_actor_get_stage (_tmp14_);
#line 490 "DragDropAction.vala"
		g_signal_parse_name ("captured-event", clutter_actor_get_type (), &_tmp16_, NULL, FALSE);
#line 490 "DragDropAction.vala"
		g_signal_handlers_disconnect_matched ((ClutterActor*) _tmp15_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp16_, 0, NULL, (GCallback) _gala_drag_drop_action_follow_move_clutter_actor_captured_event, self);
#line 1921 "DragDropAction.c"
	}
#line 492 "DragDropAction.vala"
	gala_drag_drop_action_set_dragging (self, FALSE);
#line 480 "DragDropAction.vala"
	_g_object_unref0 (source_list);
#line 1927 "DragDropAction.c"
}

GalaDragDropActionType
gala_drag_drop_action_get_drag_type (GalaDragDropAction* self)
{
	GalaDragDropActionType result;
	GalaDragDropActionType _tmp0_;
#line 100 "DragDropAction.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 100 "DragDropAction.vala"
	_tmp0_ = self->priv->_drag_type;
#line 100 "DragDropAction.vala"
	result = _tmp0_;
#line 100 "DragDropAction.vala"
	return result;
#line 1943 "DragDropAction.c"
}

static void
gala_drag_drop_action_set_drag_type (GalaDragDropAction* self,
                                     GalaDragDropActionType value)
{
#line 100 "DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 100 "DragDropAction.vala"
	if (gala_drag_drop_action_get_drag_type (self) != value) {
#line 100 "DragDropAction.vala"
		self->priv->_drag_type = value;
#line 100 "DragDropAction.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY]);
#line 1958 "DragDropAction.c"
	}
}

const gchar*
gala_drag_drop_action_get_drag_id (GalaDragDropAction* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 105 "DragDropAction.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 105 "DragDropAction.vala"
	_tmp0_ = self->priv->_drag_id;
#line 105 "DragDropAction.vala"
	result = _tmp0_;
#line 105 "DragDropAction.vala"
	return result;
#line 1975 "DragDropAction.c"
}

static void
gala_drag_drop_action_set_drag_id (GalaDragDropAction* self,
                                   const gchar* value)
{
#line 105 "DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 105 "DragDropAction.vala"
	if (g_strcmp0 (value, gala_drag_drop_action_get_drag_id (self)) != 0) {
#line 1986 "DragDropAction.c"
		gchar* _tmp0_;
#line 105 "DragDropAction.vala"
		_tmp0_ = g_strdup (value);
#line 105 "DragDropAction.vala"
		_g_free0 (self->priv->_drag_id);
#line 105 "DragDropAction.vala"
		self->priv->_drag_id = _tmp0_;
#line 105 "DragDropAction.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY]);
#line 1996 "DragDropAction.c"
	}
}

ClutterActor*
gala_drag_drop_action_get_handle (GalaDragDropAction* self)
{
	ClutterActor* result;
	ClutterActor* _tmp0_;
#line 107 "DragDropAction.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 107 "DragDropAction.vala"
	_tmp0_ = self->priv->_handle;
#line 107 "DragDropAction.vala"
	result = _tmp0_;
#line 107 "DragDropAction.vala"
	return result;
#line 2013 "DragDropAction.c"
}

static void
gala_drag_drop_action_set_handle (GalaDragDropAction* self,
                                  ClutterActor* value)
{
#line 107 "DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 107 "DragDropAction.vala"
	if (gala_drag_drop_action_get_handle (self) != value) {
#line 2024 "DragDropAction.c"
		ClutterActor* _tmp0_;
#line 107 "DragDropAction.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 107 "DragDropAction.vala"
		_g_object_unref0 (self->priv->_handle);
#line 107 "DragDropAction.vala"
		self->priv->_handle = _tmp0_;
#line 107 "DragDropAction.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY]);
#line 2034 "DragDropAction.c"
	}
}

gboolean
gala_drag_drop_action_get_dragging (GalaDragDropAction* self)
{
	gboolean result;
#line 111 "DragDropAction.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 111 "DragDropAction.vala"
	result = self->priv->_dragging;
#line 111 "DragDropAction.vala"
	return result;
#line 2048 "DragDropAction.c"
}

static void
gala_drag_drop_action_set_dragging (GalaDragDropAction* self,
                                    gboolean value)
{
#line 111 "DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 111 "DragDropAction.vala"
	if (gala_drag_drop_action_get_dragging (self) != value) {
#line 111 "DragDropAction.vala"
		self->priv->_dragging = value;
#line 111 "DragDropAction.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY]);
#line 2063 "DragDropAction.c"
	}
}

gboolean
gala_drag_drop_action_get_allow_bubbling (GalaDragDropAction* self)
{
	gboolean result;
#line 117 "DragDropAction.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 117 "DragDropAction.vala"
	result = self->priv->_allow_bubbling;
#line 117 "DragDropAction.vala"
	return result;
#line 2077 "DragDropAction.c"
}

void
gala_drag_drop_action_set_allow_bubbling (GalaDragDropAction* self,
                                          gboolean value)
{
#line 117 "DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 117 "DragDropAction.vala"
	if (gala_drag_drop_action_get_allow_bubbling (self) != value) {
#line 117 "DragDropAction.vala"
		self->priv->_allow_bubbling = value;
#line 117 "DragDropAction.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY]);
#line 2092 "DragDropAction.c"
	}
}

static void
g_cclosure_user_marshal_OBJECT__FLOAT_FLOAT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef gpointer (*GMarshalFunc_OBJECT__FLOAT_FLOAT) (gpointer data1, gfloat arg_1, gfloat arg_2, gpointer data2);
	register GMarshalFunc_OBJECT__FLOAT_FLOAT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gpointer v_return;
	cc = (GCClosure *) closure;
#line 39 "DragDropAction.vala"
	g_return_if_fail (return_value != NULL);
#line 39 "DragDropAction.vala"
	g_return_if_fail (n_param_values == 3);
#line 39 "DragDropAction.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 39 "DragDropAction.vala"
		data1 = closure->data;
#line 39 "DragDropAction.vala"
		data2 = param_values->data[0].v_pointer;
#line 2121 "DragDropAction.c"
	} else {
#line 39 "DragDropAction.vala"
		data1 = param_values->data[0].v_pointer;
#line 39 "DragDropAction.vala"
		data2 = closure->data;
#line 2127 "DragDropAction.c"
	}
#line 39 "DragDropAction.vala"
	callback = (GMarshalFunc_OBJECT__FLOAT_FLOAT) (marshal_data ? marshal_data : cc->callback);
#line 39 "DragDropAction.vala"
	v_return = callback (data1, g_value_get_float (param_values + 1), g_value_get_float (param_values + 2), data2);
#line 39 "DragDropAction.vala"
	g_value_take_object (return_value, v_return);
#line 2135 "DragDropAction.c"
}

static void
g_cclosure_user_marshal_VOID__FLOAT_FLOAT (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__FLOAT_FLOAT) (gpointer data1, gfloat arg_1, gfloat arg_2, gpointer data2);
	register GMarshalFunc_VOID__FLOAT_FLOAT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 39 "DragDropAction.vala"
	g_return_if_fail (n_param_values == 3);
#line 39 "DragDropAction.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 39 "DragDropAction.vala"
		data1 = closure->data;
#line 39 "DragDropAction.vala"
		data2 = param_values->data[0].v_pointer;
#line 2160 "DragDropAction.c"
	} else {
#line 39 "DragDropAction.vala"
		data1 = param_values->data[0].v_pointer;
#line 39 "DragDropAction.vala"
		data2 = closure->data;
#line 2166 "DragDropAction.c"
	}
#line 39 "DragDropAction.vala"
	callback = (GMarshalFunc_VOID__FLOAT_FLOAT) (marshal_data ? marshal_data : cc->callback);
#line 39 "DragDropAction.vala"
	callback (data1, g_value_get_float (param_values + 1), g_value_get_float (param_values + 2), data2);
#line 2172 "DragDropAction.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_BOOLEAN) (gpointer data1, gpointer arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 39 "DragDropAction.vala"
	g_return_if_fail (n_param_values == 3);
#line 39 "DragDropAction.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 39 "DragDropAction.vala"
		data1 = closure->data;
#line 39 "DragDropAction.vala"
		data2 = param_values->data[0].v_pointer;
#line 2197 "DragDropAction.c"
	} else {
#line 39 "DragDropAction.vala"
		data1 = param_values->data[0].v_pointer;
#line 39 "DragDropAction.vala"
		data2 = closure->data;
#line 2203 "DragDropAction.c"
	}
#line 39 "DragDropAction.vala"
	callback = (GMarshalFunc_VOID__OBJECT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 39 "DragDropAction.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_boolean (param_values + 2), data2);
#line 2209 "DragDropAction.c"
}

static void
gala_drag_drop_action_class_init (GalaDragDropActionClass * klass,
                                  gpointer klass_data)
{
#line 39 "DragDropAction.vala"
	gala_drag_drop_action_parent_class = g_type_class_peek_parent (klass);
#line 39 "DragDropAction.vala"
	g_type_class_adjust_private_offset (klass, &GalaDragDropAction_private_offset);
#line 39 "DragDropAction.vala"
	((ClutterActorMetaClass *) klass)->set_actor = (void (*) (ClutterActorMeta*, ClutterActor*)) gala_drag_drop_action_real_set_actor;
#line 39 "DragDropAction.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_drag_drop_action_get_property;
#line 39 "DragDropAction.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_drag_drop_action_set_property;
#line 39 "DragDropAction.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_drag_drop_action_finalize;
#line 2228 "DragDropAction.c"
	/**
	 * The type of the action
	 */
#line 39 "DragDropAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY] = g_param_spec_enum ("drag-type", "drag-type", "drag-type", GALA_TYPE_DRAG_DROP_ACTION_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2234 "DragDropAction.c"
	/**
	 * The unique id given to this drag-drop-group
	 */
#line 39 "DragDropAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY] = g_param_spec_string ("drag-id", "drag-id", "drag-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 39 "DragDropAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY] = g_param_spec_object ("handle", "handle", "handle", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2242 "DragDropAction.c"
	/**
	 * Indicates whether a drag action is currently active
	 */
#line 39 "DragDropAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY] = g_param_spec_boolean ("dragging", "dragging", "dragging", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2248 "DragDropAction.c"
	/**
	 * Allow checking the parents of reactive children if they are valid destinations
	 * if the child is none
	 */
#line 39 "DragDropAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY] = g_param_spec_boolean ("allow-bubbling", "allow-bubbling", "allow-bubbling", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2255 "DragDropAction.c"
	/**
	 * A drag has been started. You have to connect to this signal and
	 * return an actor that is transformed during the drag operation.
	 *
	 * @param x The global x coordinate where the action was activated
	 * @param y The global y coordinate where the action was activated
	 * @return  A ClutterActor that serves as handle
	 */
#line 39 "DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_BEGIN_SIGNAL] = g_signal_new ("drag-begin", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_OBJECT__FLOAT_FLOAT, clutter_actor_get_type (), 2, G_TYPE_FLOAT, G_TYPE_FLOAT);
#line 2266 "DragDropAction.c"
	/**
	 * A drag has been canceled. You may want to consider cleaning up
	 * your handle.
	 */
#line 39 "DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_CANCELED_SIGNAL] = g_signal_new ("drag-canceled", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2273 "DragDropAction.c"
	/**
	 * A drag action has successfully been finished.
	 *
	 * @param actor The actor on which the drag finished
	 */
#line 39 "DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_END_SIGNAL] = g_signal_new ("drag-end", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, clutter_actor_get_type ());
#line 2281 "DragDropAction.c"
	/**
	 * A drag action is moving mouse
	 *
	 * @param delta_x is the dragging distance in x-axis
	 * @param delta_y is the dragging distance in y-axis
	 */
#line 39 "DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_MOTION_SIGNAL] = g_signal_new ("drag-motion", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__FLOAT_FLOAT, G_TYPE_NONE, 2, G_TYPE_FLOAT, G_TYPE_FLOAT);
#line 2290 "DragDropAction.c"
	/**
	 * The destination has been crossed
	 *
	 * @param hovered indicates whether the actor is now hovered or not
	 */
#line 39 "DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_CROSSED_SIGNAL] = g_signal_new ("crossed", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 2298 "DragDropAction.c"
	/**
	 * Emitted on the source when a destination is crossed.
	 *
	 * @param destination The destination actor that has been crossed
	 * @param hovered     Whether the actor is now hovered or has just been left
	 */
#line 39 "DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DESTINATION_CROSSED_SIGNAL] = g_signal_new ("destination-crossed", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN, G_TYPE_NONE, 2, clutter_actor_get_type (), G_TYPE_BOOLEAN);
#line 2307 "DragDropAction.c"
	/**
	 * The source has been clicked, but the movement was not larger than
	 * the drag threshold. Useful if the source is also activable.
	 *
	 * @param button The button which was pressed
	 */
#line 39 "DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL] = g_signal_new ("actor-clicked", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
#line 2316 "DragDropAction.c"
}

static void
gala_drag_drop_action_instance_init (GalaDragDropAction * self,
                                     gpointer klass)
{
#line 39 "DragDropAction.vala"
	self->priv = gala_drag_drop_action_get_instance_private (self);
#line 111 "DragDropAction.vala"
	self->priv->_dragging = FALSE;
#line 117 "DragDropAction.vala"
	self->priv->_allow_bubbling = TRUE;
#line 122 "DragDropAction.vala"
	self->allow_direction = GALA_DRAG_DROP_ACTION_DIRECTION_ALL;
#line 128 "DragDropAction.vala"
	self->allow_y_overflow = 0.0f;
#line 131 "DragDropAction.vala"
	self->priv->hovered = NULL;
#line 132 "DragDropAction.vala"
	self->priv->clicked = FALSE;
#line 2337 "DragDropAction.c"
}

static void
gala_drag_drop_action_finalize (GObject * obj)
{
	GalaDragDropAction * self;
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
#line 39 "DragDropAction.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction);
#line 160 "DragDropAction.vala"
	_tmp0_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 160 "DragDropAction.vala"
	_tmp1_ = _tmp0_;
#line 160 "DragDropAction.vala"
	if (_tmp1_ != NULL) {
#line 2354 "DragDropAction.c"
		ClutterActor* _tmp2_;
		ClutterActor* _tmp3_;
#line 161 "DragDropAction.vala"
		_tmp2_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 161 "DragDropAction.vala"
		_tmp3_ = _tmp2_;
#line 161 "DragDropAction.vala"
		gala_drag_drop_action_release_actor (self, _tmp3_);
#line 2363 "DragDropAction.c"
	}
#line 105 "DragDropAction.vala"
	_g_free0 (self->priv->_drag_id);
#line 107 "DragDropAction.vala"
	_g_object_unref0 (self->priv->_handle);
#line 131 "DragDropAction.vala"
	_g_object_unref0 (self->priv->hovered);
#line 138 "DragDropAction.vala"
	__vala_ClutterPoint_free0 (self->priv->offset);
#line 39 "DragDropAction.vala"
	G_OBJECT_CLASS (gala_drag_drop_action_parent_class)->finalize (obj);
#line 2375 "DragDropAction.c"
}

GType
gala_drag_drop_action_get_type (void)
{
	static volatile gsize gala_drag_drop_action_type_id__volatile = 0;
	if (g_once_init_enter (&gala_drag_drop_action_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaDragDropActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_drag_drop_action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaDragDropAction), 0, (GInstanceInitFunc) gala_drag_drop_action_instance_init, NULL };
		GType gala_drag_drop_action_type_id;
		gala_drag_drop_action_type_id = g_type_register_static (clutter_action_get_type (), "GalaDragDropAction", &g_define_type_info, 0);
		GalaDragDropAction_private_offset = g_type_add_instance_private (gala_drag_drop_action_type_id, sizeof (GalaDragDropActionPrivate));
		g_once_init_leave (&gala_drag_drop_action_type_id__volatile, gala_drag_drop_action_type_id);
	}
	return gala_drag_drop_action_type_id__volatile;
}

static void
_vala_gala_drag_drop_action_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	GalaDragDropAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction);
#line 39 "DragDropAction.vala"
	switch (property_id) {
#line 39 "DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY:
#line 39 "DragDropAction.vala"
		g_value_set_enum (value, gala_drag_drop_action_get_drag_type (self));
#line 39 "DragDropAction.vala"
		break;
#line 39 "DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY:
#line 39 "DragDropAction.vala"
		g_value_set_string (value, gala_drag_drop_action_get_drag_id (self));
#line 39 "DragDropAction.vala"
		break;
#line 39 "DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY:
#line 39 "DragDropAction.vala"
		g_value_set_object (value, gala_drag_drop_action_get_handle (self));
#line 39 "DragDropAction.vala"
		break;
#line 39 "DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY:
#line 39 "DragDropAction.vala"
		g_value_set_boolean (value, gala_drag_drop_action_get_dragging (self));
#line 39 "DragDropAction.vala"
		break;
#line 39 "DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY:
#line 39 "DragDropAction.vala"
		g_value_set_boolean (value, gala_drag_drop_action_get_allow_bubbling (self));
#line 39 "DragDropAction.vala"
		break;
#line 2432 "DragDropAction.c"
		default:
#line 39 "DragDropAction.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 39 "DragDropAction.vala"
		break;
#line 2438 "DragDropAction.c"
	}
}

static void
_vala_gala_drag_drop_action_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	GalaDragDropAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction);
#line 39 "DragDropAction.vala"
	switch (property_id) {
#line 39 "DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY:
#line 39 "DragDropAction.vala"
		gala_drag_drop_action_set_drag_type (self, g_value_get_enum (value));
#line 39 "DragDropAction.vala"
		break;
#line 39 "DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY:
#line 39 "DragDropAction.vala"
		gala_drag_drop_action_set_drag_id (self, g_value_get_string (value));
#line 39 "DragDropAction.vala"
		break;
#line 39 "DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY:
#line 39 "DragDropAction.vala"
		gala_drag_drop_action_set_handle (self, g_value_get_object (value));
#line 39 "DragDropAction.vala"
		break;
#line 39 "DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY:
#line 39 "DragDropAction.vala"
		gala_drag_drop_action_set_dragging (self, g_value_get_boolean (value));
#line 39 "DragDropAction.vala"
		break;
#line 39 "DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY:
#line 39 "DragDropAction.vala"
		gala_drag_drop_action_set_allow_bubbling (self, g_value_get_boolean (value));
#line 39 "DragDropAction.vala"
		break;
#line 2482 "DragDropAction.c"
		default:
#line 39 "DragDropAction.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 39 "DragDropAction.vala"
		break;
#line 2488 "DragDropAction.c"
	}
}

